AIPlayer = class(function(self, Name, Character)
	self.Name = Name
	self.Character = Character;
	self.CharacterSkin = 0
	self.Classes = {}
	self.Skill = 1
end)

function AIPlayer:AddCar(Class, Car, Skin)
	if (Car == nil) then
		return
	end
	local Item = {}
	Item.Class  = Class;
	Item.Car = Car;
	Item.Skin = Skin
	table.insert(self.Classes, Item)
end

function AIPlayer:SetSkill(Skill)
	self.Skill = Skill
end

function AIPlayer:GetCar(AvailableClasses)
	local Options = {}
	for i, Class in ipairs(self.Classes) do
		for j, AvailableClass in ipairs(AvailableClasses) do
			if (Class.Class == AvailableClass) then
				--print(AvailableClass.Name)
				--print(Class.Class.Name)
				--print(Class.Car.Name)
				
				local Option = {}
				Option.Car = Class.Car.Name
				Option.Skin = Class.Skin
				table.insert(Options, Option)
			end
		end
	end
	
	if (#Options ~= 0) then
		local Option = Options[math.random(1, #Options)];
		
		return Option.Car, Option.Skin
	else
		return nil, nil
	end
end
		