function SmartBindInternal(Modifier, Listener)
	if (type(Modifier) == "string") then
		Modifier = GetKeyCode(Modifier)
	end

	if (KeyPressed(Modifier)) then
		Listener()

		return true
	else
		return false
	end
end

function SmartBind(KeyName, Type, Modifiers, Listener)
	bind(KeyName , Type, function()
		if (Modifiers ~= nil) then
			if (type(Modifiers) == "table") then
				for i = 1, #Modifiers do
					if (SmartBindInternal(Modifiers[i], Listener)) then
						break
					end
				end
			else
				SmartBindInternal(Modifiers, Listener)
			end
		else
			Listener()
		end
	end)
end

-- Knoppen die handig zijn
Alt = { GetKeyCode("DCK_LALT"), GetKeyCode("DCK_RALT") }
Ctrl = { GetKeyCode("DCK_LCONTROL"), GetKeyCode("DCK_RCONTROL") }
Shift = { GetKeyCode("DCK_LSHIFT"), GetKeyCode("DCK_RSHIFT") }