Box = class(function(self, Center, Extents)
	self.Center = Center
	self.Extents = Extents
end)

function Box:Intersect(Pos)
	local Dist = (self.Pos - Pos)
	
	if (Dist.x < -self.Extents.x and
		Dist.x > self.Extents.x and
		Dist.y < -self.Extents.y and
		Dist.y > self.Extents.y and
		Dist.z < -self.Extents.z and
		Dist.z > self.Extents.z) then

		return true
	else
		return false
	end
end