Kiip = class(function(self)
	self.RewardAvailable = false
	
	if (Kiip_SetContentListener ~= nil) then
		local ContentCallback = function(Quantity) 
			self:OnContent(tonumber(Quantity))
		end
		Kiip_SetContentListener(ContentCallback)
	end
end)

function Kiip:OnContent(Quantity)
	print("Kiip:OnContent(Quantity)")
	print(Quantity)
	
	if (Quantity > 0) then
		--VirtualCoins:AddGoloCoinCount(Quantity)
		VirtualCoins:AddCoinCount(Quantity)
	end
end

function Kiip:OnUpdateUserInfo(UserinfoTable)
	print("Kiip:OnUpdateUserInfo(UserinfoTable)")
	if (Kiip_SetUserInfo ~= nil) then
		local Email = UserinfoTable['email']
		local Gender = UserinfoTable['gender']
		local Birthday = UserinfoTable['birthday']
		if (Email == nil) then Email = "" end
		if (Gender == nil) then Gender = "" end
		if (Birthday == nil) then Birthday = "" end
		Kiip_SetUserInfo(Email, Gender, Birthday)
	end
end

function Kiip:SaveMoment(MomentID)
	local SuccessCallback = function(IsRewardAvailable) 
		print("SaveMoment - SuccessCallback")
		self.RewardAvailable = IsRewardAvailable == "true" and true or false
	end
	
	local FailureCallback = function()
		print("SaveMoment - FailureCallback")
	end
	
	if (Kiip_SaveMoment ~= nil) then
		Kiip_SaveMoment(MomentID, SuccessCallback, FailureCallback)
	else
		self.RewardAvailable = true
	end
end

function Kiip:RedeemReward()
	self.RewardAvailable = false
	if (Kiip_ShowPoptart ~= nil) then
		Kiip_ShowPoptart()
	else
		self:OnContent(1)
	end
end