Plane = class(function(self, Pos, Normal)
	self.Normal = Normal
	self.Distance = Pos:Dot(Normal)
end)

function Plane:Intersect(Pos)
	local Dist = self.Normal:Dot(Pos) - self.Distance
	return Dist > 0
end

function GetCamPlane()
	local Matrix = GetCamMatrix(0)

	local Pos = Matrix:GetTranslation()

	local Dir = Matrix:GetDirection()

	print("CamPlane: Pos = " .. tostring(Pos) .. " Normal = " .. tostring(Dir))

	print("ReverseCamPlane: Pos = " .. tostring(Pos) .. " Normal = " .. tostring(-Dir))

	local CamPlane = Plane(Pos, Dir);

	print("Plane Data: Normal = " .. tostring(CamPlane.Normal) .. " Distance = " .. CamPlane.Distance)
end

function BindCar()
	GameThread:Spawn(function()
		while (true) do
			GetCar(0):SetMatrix(GetCamMatrix())
			GameThread:Wait(1)
		end 
	end)
end