Test = GameMode("Test")
function Test:HUD(...)
	return HUD_Test(...)
end

Test.AICount = { "4", "5", "6", "7"}
Test.ActiveAICount = 1;

Test.LapCount = {"1", "3", "5"}
Test.ActiveLapCount = 0

Test.AIDifficulty = {"ai_difficulty_easy", "ai_difficulty_normal", "ai_difficulty_hard"}
Test.ActiveAIDifficulty = 0;

Test.PhysicsSpeedValues = {"0.84"}
Test.ActivePhysicsSpeed = 0

Test.TimeLimit = {"0"}
Test.ActiveTimeLimit = 0

Test.RaceUnlockText = "NEW_RACE_UNLOCKED"

Test:AddCarClass(MonsterTruckCars);

function Test:PrepareScript(RaceData)
	ActiveMission = TestMission(RaceData)
	
	--betere plek zoeken?
	--Camera = LuaCamera("naam")
	--Camera:DisableLerp()
	--Camera:Disable(false)
	
	--local LookFrom = TriggerTargetID("IngameBook")
	--Camera:SetLookFrom(LookFrom)
	--Camera:SetLookAt(0)
end

function Test:Won()
	--Steam_SetAchievement("STUNTFINISHED")
end

-- Add chapters
local Chapter1 = Test:AddChapter(Chapter("Race_Chapter1"))

-- Add chapter 1 races
local NewRace = Chapter1:AddRace(Mission("Race"))
NewRace.Available = true;

NewRace.Won = function(self, Place, Score)
	return Place >= 3
end


function Test:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	-- Race data
	RaceData.LapCount = 3
	
	if (Career == nil) then
		Career = false
	end
	RaceData.Career = Career

	-- De speler
	RaceData.Name = GetPlayername() --steam_getname();
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.Tuning = "Default"
	RaceData.CarType = _G[Car]

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadscript(Race)
end