HUD_E_BonusTime = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.BonusText = self.Item:GetChild("BonusText_Flash")
	self.StartColor = color(0.8, 0.8, 0.8, 1)
	self.EndColor = color(0.8, 0.8, 0.8, 0)
	self.PulseDelay = 120
	self.PulseSpeed = 1
	self.PulseThread = nil
	self.BonusText:SetColor(Invisible)
end)

function HUD_E_BonusTime:Show(Force)
	--
end

function HUD_E_BonusTime:Hide()
	--
end

function HUD_E_BonusTime:Start()
	self.BonusText:SetColor(self.StartColor)
	
	PulseThread = PhysicsThread:Spawn(function()
		PhysicsThread:Wait(self.PulseDelay)
		
		self:Pulse(self.PulseSpeed)
		
		PhysicsThread:Wait(self.PulseSpeed * 60)
		
		self:End()
	end)
end

function HUD_E_BonusTime:Pulse(Speed)
	self.BonusText:SetColorData(self.EndColor, 1, Sine, false)
end

function HUD_E_BonusTime:End()
	if (self.PulseThread ~= nil) then
		PhysicsThread:Stop(self.PulseThread)
		self.PulseThread = nil
	end
end