HUD_E_TutorialText = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.TutorialText = self.Item:GetChild("TutorialText")
	
	self.Item:SetColorImmediate(Invisible)
	self.TutorialText:SetColorImmediate(Invisible)
	
	self:SetFont("ArialBlack70")
	self:SetText("")
end)

function HUD_E_TutorialText:Show(Force)
	--
end

function HUD_E_TutorialText:Hide(Force)
	--
end

function HUD_E_TutorialText:Flash(FadeSpeed)
	if (FadeSpeed == nil) then
		FadeSpeed = 3
	end
end

function HUD_E_TutorialText:SetText(Text)	
	if (Text == "") then
		self.Item:SetColor(Invisible)
		self.Item:SetColorFade(1, 3)
	else
		self.Item:SetColorImmediate(Invisible)
		self.Item:SetColor(White)
		self.Item:SetColorFade(1, 3)
	end
	
	if (Text ~= "") then
		self.TutorialText:SetColorImmediate(Invisible)
		self.TutorialText:SetColor(White)
		self.TutorialText:SetColorFade(1, 3)
		self.TutorialText:SetText(Text)
	end
end

function HUD_E_TutorialText:SetFont(Font)
	--
end