HUD_Destroyer = class(HUD_Base, function(self, Mission, Player)
	-- HealthBar Element
	local LocationData = {128,64,0,0,0,0}
	self.HealthBar = HUD_E_HealthBar(self, self.SafeFrame, "hud_HealthBar", LocationData)
	table.insert(self.HUDElements, self.HealthBar)
	
	-- Score Element
	local LocationData = {-80,20,Right,Top,Right,Top}
	self.ScoreElement = HUD_E_ScoreElement(self, self.SafeFrame, "hud_ScoreCost", LocationData)
	table.insert(self.HUDElements, self.ScoreElement)
	self.ScoreElement:SetFont("ArialBlack90")
	--self.ScoreElement:ShowIcon()
	
	-- Time Element
	local LocationData = {0, 0, 0.5, 0, 0.5, 0}
	self.Timer = HUD_E_Timer(self, self.SafeFrame, "hud_Timer", LocationData)
	table.insert(self.HUDElements, self.Timer)
	self.Timer:SetFont("ArialBlack90")
	self.Timer.UseShortTime = true

	-- Bonus Time Text popup
	local LocationData = {0, 128, 0.5, 0, 0.5, 0}
	self.BonusTimePopup = HUD_E_BonusTime(self, self.SafeFrame, "hud_BonusTime", LocationData)
	table.insert(self.HUDElements, self.BonusTimePopup)
	
	-- TutorialText Element
	local LocationData = {0, 0, Center, Center, Center, 0.3}
	self.TutorialText = HUD_E_TutorialText(self, self.SafeFrame, "hud_TutorialText", LocationData)
	table.insert(self.HUDElements, self.TutorialText)
end)