HUD_FrameTwister = class(HUD_Base, function(self, Mission, Player)
	-- Score Element
	local LocationData = {0,20,Center,Top,Center,Top}
	self.ScoreElement = HUD_E_ScoreElement(self, self.SafeFrame, "hud_Score", LocationData)
	table.insert(self.HUDElements, self.ScoreElement)
	self.ScoreElement:ShowIcon()

	-- HealthBar Element
	local LocationData = {128,20,Left,Top,Left,Top}
	self.HealthBar = HUD_E_HealthBar(self, self.SafeFrame, "hud_HealthBar", LocationData)
	table.insert(self.HUDElements, self.HealthBar)
end)

function HUD_FrameTwister:SetScore(Score)
	if (self.ScoreElement ~= nil) then
		self.ScoreElement:SetScore(Round(Score))
	end
end