HUD_FreestyleFest = class(HUD_Base, function(self, Mission, Player)
	-- Time Element
	local LocationData = {0, 0, 0.5, 0, 0.5, 0}
	self.Timer = HUD_E_Timer(self, self.SafeFrame, "hud_Timer", LocationData)
	table.insert(self.HUDElements, self.Timer)
	self.Timer:SetFont("ArialBlack90")
	
	-- StuntButton
	local LocationData = {0,0,1,0,1,0}
	self.StuntButton = HUD_E_SimpleScreenButton(self, self.SafeFrame, "hud_SimpleScreenButton", LocationData, "DCK_SCREENBUTTON_5")
	self.StuntButton:SetText("!")
	table.insert(self.HUDElements, self.StuntButton)
	
	-- StuntList
	local LocationData = {0, 0, 0.875, 0, 0.875, 0}
	self.StuntList = HUD_E_StuntList(self, self.SafeFrame, "hud_StuntList", LocationData, nil, nil, self.StuntButton)
	table.insert(self.HUDElements, self.StuntList)
	
	-- Bonus Time Text popup
	local LocationData = {0, 128, 0.5, 0, 0.5, 0}
	self.BonusTimePopup = HUD_E_BonusTime(self, self.SafeFrame, "hud_BonusTime", LocationData)
	table.insert(self.HUDElements, self.BonusTimePopup)
	
	-- TutorialText Element
	local LocationData = {0, 0, Center, Center, Center, 0.3}
	self.TutorialText = HUD_E_TutorialText(self, self.SafeFrame, "hud_TutorialText", LocationData)
	table.insert(self.HUDElements, self.TutorialText)
end) 