--Logitech Dual Action USB

function configuredevice(InstanceID)
	--Default settings
	var(InstanceID .. "_" .. "Configured", "1")
	var(InstanceID .. "_" .. "MenuKeys[0]_0", "DCK_RETURN")
	var(InstanceID .. "_" .. "MenuKeys[0]_1", "DCK_ENTER")
	var(InstanceID .. "_" .. "MenuKeys[1]_0", "DCK_ESCAPE")
	var(InstanceID .. "_" .. "MenuKeys[3]_0", "DCK_ESCAPE")
	var(InstanceID .. "_" .. "MenuKeys[5]_0", "DCK_LEFT")
	var(InstanceID .. "_" .. "MenuKeys[6]_0", "DCK_DOWN")
	var(InstanceID .. "_" .. "MenuKeys[7]_0", "DCK_UP")
	var(InstanceID .. "_" .. "MenuKeys[8]_0", "DCK_RIGHT")
	var(InstanceID .. "_" .. "MenuKeys[9]_0", "DCK_TAB")
	
	var(InstanceID .. "_" .. "MenuKeys[0]_2", "DCK_XBOX0_A")
	var(InstanceID .. "_" .. "MenuKeys[1]_3", "DCK_XBOX0_B")
	var(InstanceID .. "_" .. "MenuKeys[3]_2", "DCK_XBOX0_START")
	var(InstanceID .. "_" .. "MenuKeys[5]_2", "DCK_XBOX0_LTHUMB_LEFT")
	var(InstanceID .. "_" .. "MenuKeys[5]_3", "DCK_XBOX0_DPAD_LEFT")
	var(InstanceID .. "_" .. "MenuKeys[6]_2", "DCK_XBOX0_LTHUMB_DOWN")
	var(InstanceID .. "_" .. "MenuKeys[6]_3", "DCK_XBOX0_DPAD_DOWN")
	var(InstanceID .. "_" .. "MenuKeys[7]_2", "DCK_XBOX0_LTHUMB_UP")
	var(InstanceID .. "_" .. "MenuKeys[7]_3", "DCK_XBOX0_DPAD_UP")
	var(InstanceID .. "_" .. "MenuKeys[8]_2", "DCK_XBOX0_LTHUMB_RIGHT")
	var(InstanceID .. "_" .. "MenuKeys[8]_3", "DCK_XBOX0_DPAD_RIGHT")

	
	--Joystick settings
	var(InstanceID .. "_" .. "MenuKeys[0]_3", "DCK_JOY_BUTTON1")
	var(InstanceID .. "_" .. "MenuKeys[1]_1", "DCK_JOY_BUTTON2")
	var(InstanceID .. "_" .. "MenuKeys[3]_1", "DCK_JOY_BUTTON9")
	var(InstanceID .. "_" .. "MenuKeys[5]_1", "DCK_JOY_POV_LEFT")
	var(InstanceID .. "_" .. "MenuKeys[6]_1", "DCK_JOY_POV_DOWN")
	var(InstanceID .. "_" .. "MenuKeys[7]_1", "DCK_JOY_POV_UP")
	var(InstanceID .. "_" .. "MenuKeys[8]_1", "DCK_JOY_POV_RIGHT")
	
	var(InstanceID .. "_" .. "CharacterKeys[0]_0", "DCK_JOY_POSX_POS")
	var(InstanceID .. "_" .. "CharacterKeys[1]_0", "DCK_JOY_POSX_NEG")
	var(InstanceID .. "_" .. "CharacterKeys[2]_0", "DCK_JOY_POSY_POS")
	var(InstanceID .. "_" .. "CharacterKeys[3]_0", "DCK_JOY_POSY_NEG")

	var(InstanceID .. "_" .. "ForwardKey_0", "DCK_JOY_BUTTON7")
	var(InstanceID .. "_" .. "ReverseKey_0", "DCK_JOY_BUTTON6")
	var(InstanceID .. "_" .. "LeftKey_0", "DCK_JOY_POSX_POS")
	var(InstanceID .. "_" .. "RightKey_0", "DCK_JOY_POSX_NEG")

	var(InstanceID .. "_" .. "HandbrakeKey_0", "DCK_JOY_BUTTON2")
	var(InstanceID .. "_" .. "HandbrakeKey_1", "")

	var(InstanceID .. "_" .. "BoostKey_0", "DCK_JOY_BUTTON1")
	var(InstanceID .. "_" .. "BoostKey_1", "")

	var(InstanceID .. "_" .. "RespawnKey_0", "DCK_JOY_BUTTON8")
	var(InstanceID .. "_" .. "ToggleLightsKey_0", "DCK_JOY_BUTTON5")
	var(InstanceID .. "_" .. "HornKey_0", "DCK_JOY_BUTTON11")

	var(InstanceID .. "_" .. "LookBackKey_0", "DCK_JOY_POV_DOWN")
	var(InstanceID .. "_" .. "ChangeCameraKey_0", "DCK_JOY_POV_UP")

	var(InstanceID .. "_" .. "CarJumpKey_0", "DCK_JOY_BUTTON3")
	var(InstanceID .. "_" .. "CarUniqueKey_0", "DCK_JOY_BUTTON4")

	var(InstanceID .. "_" .. "PrevTrackKey_0", "DCK_JOY_POV_LEFT")
	var(InstanceID .. "_" .. "NextTrackKey_0", "DCK_JOY_POV_RIGHT")
end