MenuElements.FakeButton = class(function(self, ItemList, Template, ControlList)
	self.Item = MenuItem(Template)
	self.ControlList = ControlList
	self.Enabled = true

	-- Init
	-- Functions

end)

function MenuElements.FakeButton:DelItem(Index)
	self.Panel:DelItem(self.Item)
end

function MenuElements.FakeButton:Activate()
	if (self.Enabled) then
		if (self.OnActivate ~= nil) then
			self.OnActivate()
		end
	end	
end

function MenuElements.FakeButton:Deactivate()
	if (self.Enabled) then
		if (self.OnDeactivate ~= nil) then
			self.OnDeactivate()
		end
	end
end

function MenuElements.FakeButton:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		

	end
end

function MenuElements.FakeButton:Disable()
	if (self.Enabled) then
		self.Enabled = false
	end
end

function MenuElements.FakeButton:Left()
	if (self.ControlList ~= nil) then
		return self.ControlList:Prev()
	end
	return false
end

function MenuElements.FakeButton:Right()
	if (self.ControlList ~= nil) then
		return self.ControlList:Next()
	end
	return false
end