-- text item
MenuElements.Chapter = class(function(self, ItemList, Template, Chapter)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Chapter = Chapter

	self.Item:SetColorFade(1, 8)
	
	self.NameItem = self.Item:GetChild("Name")
	--self.NameItem2 = self.Item:GetChild("Name2")
	self.ImageItem = self.Item:GetChild("Image")
	self.LockedText = self.Item:GetChild("LockedText")
	
	self.Color = White;
	self.FlashColor = White;
	
	print(Chapter.Texture)
	
	-- Init
	
	self.Item:SetColorImmediate(Halfblack)
	
	self.NameItem:SetText(Translate(Chapter.Title))
	self.NameItem:SetColorFade(1, 10)
	self.NameItem:SetColorImmediate(self.Color);
	
	--self.NameItem2:SetText(Translate(Name))
	--self.NameItem2:SetColorFade(1, 4)
	--self.NameItem2:SetColorImmediate(Invisible);
	
	if (Chapter.Locked) then
		self.LockedText:SetColorImmediate(White)
	end
	
	--if (Chapter.ChapterImage ~= nil) then
	if (Chapter.Texture ~= nil) then
		self.ImageItem:SetImage(Chapter.Texture)
	end

	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			--ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)

	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.Chapter:SetText(Text)
	self.NameItem:SetText(translate(Text))
	--self.NameItem2:SetText(translate(Text))
end

function MenuElements.Chapter:Activate() -- standaard multilist selectie kleuren 
	self.Item:SetColorImmediate(White)
	--self.Item:SetColor(SelectDarkOrange)

	self.NameItem:SetColor(White)

	--self.NameItem2:SetColorImmediate(White)
	--self.NameItem2:SetColor(Invisible)
end

function MenuElements.Chapter:Deactivate()
	self.Item:SetColor(Halfblack)
	--self.NameItem:SetColor(Darkish)
	--self.NameItem2:SetColorImmediate(Invisible)
end

function MenuElements.Chapter:DelItem(Index)
	--self.Panel:DelItem(Index)
end