-- text item
MenuElements.Character = class(function(self, ItemList, Template, Character)
	self.Panel = ItemList.Panel
	self.Enabled = true
	self.Character = Character

	--self.Item = self.Panel:AddItem(Template);
	self.Item = MenuItem(Template)
	self.Item:SetColorFade(1, 8)
	
	self.MessageNewImage = self.Item:GetChild("MessageNew")
	
	self.CharacterImage = self.Item:GetChild("CharacterImage")
	self.CharacterImageFlash = self.Item:GetChild("CharacterImageFlash")
	
	if (self.Character ~= nil and self.Character.Image ~= nil) then
		self.CharacterImage:SetImage(Character.Image)
		self.CharacterImageFlash:SetImage(Character.Image)
	end
	
	if (self.Character ~= nil) then
		self.MessageNewImage:SetColorImmediate(Invisible)
	else
		self.MessageNewImage:SetColorImmediate(White)
	end
	
	
	--self.NameItem = self.Item:GetChild("Name")
	--self.NameItem2 = self.Item:GetChild("Name2")
	--self.ImageItem = self.Item:GetChild("Image")
	--self.LockedText = self.Item:GetChild("LockedText")
	
	--self.Color = White;
	--self.FlashColor = White;
	
	-- Init
	
	--self.Item:SetColorImmediate(Halfblack)
	
	--self.NameItem:SetText(Translate(Chapter.Title))
	--self.NameItem:SetColorFade(1, 10)
	--self.NameItem:SetColorImmediate(self.Color);
	
	--self.NameItem2:SetText(Translate(Name))
	--self.NameItem2:SetColorFade(1, 4)
	--self.NameItem2:SetColorImmediate(Invisible);
	
	--if (Chapter.Locked) then
		--self.LockedText:SetColorImmediate(White)
	--end
	
	--if (Chapter.ChapterImage ~= nil) then
		--self.ImageItem:SetImage(Chapter.ChapterImage)
	--end
	
	local AlignX = 1
	local AlignY = 1
	local ScreenAlignX = 1
	local ScreenAlignY = 0
	self.MessageNewImage:SetPosData(0, 0, AlignX, AlignY, ScreenAlignX, ScreenAlignY, 0, 0, false)

	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)
		
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			--ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)

	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.Character:SetText(Text)
	--self.NameItem:SetText(translate(Text))
	--self.NameItem2:SetText(translate(Text))
end

function MenuElements.Character:Select()
	
end

function MenuElements.Character:Unselect()
	
end

function MenuElements.Character:Activate() -- standaard multilist selectie kleuren 

	local AlignX = 1
	local AlignY = 0
	local ScreenAlignX = 1
	local ScreenAlignY = 0
	self.MessageNewImage:SetPosDataTween(0, 0, AlignX, AlignY, ScreenAlignX, ScreenAlignY, 1, 0, false, EASE_OUT_BOUNCE)

	--self.Item:SetColorImmediate(White)
	--self.Item:SetColor(SelectDarkOrange)

	--self.NameItem:SetColor(White)

	--self.NameItem2:SetColorImmediate(White)
	--self.NameItem2:SetColor(Invisible)
end

function MenuElements.Character:Deactivate()
	--self.Item:SetColor(Halfblack)
	--self.NameItem:SetColor(Darkish)
	--self.NameItem2:SetColorImmediate(Invisible)
	
	local AlignX = 1
	local AlignY = 1
	local ScreenAlignX = 1
	local ScreenAlignY = 0
	--self.MessageNewImage:SetPosData(0, 0, AlignX, AlignY, ScreenAlignX, ScreenAlignY, 0, 0, false)
	self.MessageNewImage:SetPosDataTween(0, 0, AlignX, AlignY, ScreenAlignX, ScreenAlignY, 1, 0, false, EASE_LINEAR)
end

function MenuElements.Character:DelItem(Index)
	--self.Panel:DelItem(Index)
end
