MenuElements.ColorButton = class(function(self, ItemList, Template)
	self.Item = MenuItem(Template)
	self.Enabled = true
	self.Text = ""

	-- self.Item = self.Panel:AddItem(Template);
	self.Item:SetColorFade(1, 8)
	
	self.ImageItem = self.Item:GetChild("Image")
	self.Background = self.Item:GetChild("Background")
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameFlashItem = self.Item:GetChild("NameFlash")
	
	--self.ItemNumberItem = self.Item:GetChild("ItemNumber")
	--self.ItemNumberFlashItem = self.Item:GetChild("ItemNumberFlash")
	
	--self.StatusTextItem = self.Item:GetChild("StatusText")
	--self.StatusTextFlashItem = self.Item:GetChild("StatusTextFlash")
	
	--self.PricePanelItem = self.Item:GetChild("PricePanel")
	--self.ValueItem = self.Item:GetChild("Value")
	--self.ValueFlashItem = self.Item:GetChild("ValueFlash")
	

	
	--self.Car = Car
	--[[ if (self.Car ~= nil) then
		self.ItemNumberItem:SetText(Index .. ".")
		self.ItemNumberFlashItem:SetText(Index .. ".")
	
		self.NameItem:SetText(Translate(self.Car.Title))
		self.NameFlashItem:SetText(Translate(self.Car.Title))
		
		if (Bought) then
			--Price
			self.PricePanelItem:SetColorImmediate(Invisible)
		else
			--Price
			self.PricePanelItem:SetColorImmediate(White)
			self.ValueItem:SetText(self.Car.ShopPriceCoins)
			self.ValueFlashItem:SetText(self.Car.ShopPriceCoins)
		end
	end ]]--
	
	--[[ if (self.Car.ColorConfig ~= nil and self.Car.ColorConfig[Index] ~= nil) then
		local Color = self.Car.ColorConfig[Index]
		self.ImageItem:SetColor(Color / 255)
		
		self.CarColor = (Color / 255)
	else
		self.ImageItem:SetColor(Black)
		
		self.CarColor = Black
	end ]]--
	
	self:SetColor(White)
	
	self:SetText("")
	
	
	
	self.Color = White;
	self.FlashColor = White;
	
	self.Texture = Texture
	
	
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
	
	if (self.Texture ~= nil) then
		--self.ImageItem:SetImage(self.Texture)
	end


	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			--[[ ItemList:SetSelection(self)
			
			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end ]]--
		end
	end)

	self.Item:SetDeactivateFunc(function()
		--[[ if (self.Enabled) then
			ItemList:UnsetSelection(self)
				
			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end ]]--
	end)
	
	self.Item:SetClickedFunc(function()
		if (self.Enabled) then
			--ItemList:SetSelection(self)

			if (self.OnClicked ~= nil) then
				self.OnClicked()
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnReleased ~= nil) then
				self.OnReleased()
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)













function MenuElements.ColorButton:SetText(Text)
	self.NameItem:SetText(Text)
	self.NameFlashItem:SetText(Text)
	self.Text = Text
end

function MenuElements.ColorButton:SetColor(Color)
	self.ImageItem:SetColor(Color)
	self.Color = Color
	
	--Tijdelijk
	--[[ local Color_R = string.format("%.3f", self.Color:getr())
	local Color_G = string.format("%.3f", self.Color:getg())
	local Color_B = string.format("%.3f", self.Color:getb())
	local Color_Text =  "(" .. Color_R .. ", " .. Color_G .. ", " .. Color_B .. ")"
	
	local Color_R = string.format("%.0f", self.Color:getr() * 255)
	local Color_G = string.format("%.0f", self.Color:getg() * 255)
	local Color_B = string.format("%.0f", self.Color:getb() * 255)
	local Color_Text_255 =  "(" .. Color_R .. ", " .. Color_G .. ", " .. Color_B .. ")"
	
	local Text = self.Text .. Translate("newline") .. Color_Text .. Translate("newline") .. Color_Text_255
	self.NameItem:SetText(Text)
	self.NameFlashItem:SetText(Text) ]]
end

function MenuElements.ColorButton:Select()
	
end

function MenuElements.ColorButton:Unselect()
	
end

function MenuElements.ColorButton:Activate() -- standaard multilist selectie kleuren 
	self.Background:SetColorData(color(0.35, 0.35, 0.35, 1), 0, None, false)
end

function MenuElements.ColorButton:Deactivate()
	self.Background:SetColorData(color(0.2, 0.2, 0.2, 1), 0, None, false)
end

function MenuElements.ColorButton:Flash(Speed)
	
end

function MenuElements.ColorButton:DelItem(Index)
	--
end