-- text item
MenuElements.ResultSinglePlayerScores = class(function(self, ItemList, Template, Name, Total, Score)
	self.Item = MenuItem(Template)
	self.Item:SetColorFade(1, 8)

	self.NameItem = self.Item:GetChild("Name")

	self.PlayerColor = self.Item:GetChild("PlayerColor")
	
	self.Value = self.Item:GetChild("Value")
	
	self.Score = self.Item:GetChild("Score")
	
	-- Init

	self.NameItem:SetText(string.upper(translate(Name)))
	
	self.Results = {}
	self.Results["LEFT"] = {Total, Score}
	
	self.Value:SetText(self.Results["LEFT"][1])
	self.Score:SetText(self.Results["LEFT"][2])
	
	--self:SetRandomScores()
end)

function MenuElements.ResultSinglePlayerScores:SetRandomScores() -- testing only

	-- [value x] [multiplier =] [score]

	self.Value = self.Item:GetChild("Value")
	self.Score = self.Item:GetChild("Score")
	
	local RandomValue = math.random (0, 100)
	local RandomMultiplier = (math.random (1, 3)) * 10
	
	if RandomMultiplier == 30 then
		RandomMultiplier = RandomMultiplier + 10
	end

	local Score = RandomValue * RandomMultiplier
	
	--self.Value_Left:SetText(RandomValue .. " x " .. RandomMultiplier .. " = " .. Score) -- score 1
	self.Value:SetText(RandomValue)
	self.Score:SetText(Score)
end

function MenuElements.ResultSinglePlayerScores:SetText(Text)
	--
end

function MenuElements.ResultSinglePlayerScores:Activate() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultSinglePlayerScores:Clicked() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultSinglePlayerScores:Deactivate()
	--
end

function MenuElements.ResultSinglePlayerScores:DelItem(Index)
	--
end

function MenuElements.ResultSinglePlayerScores:Enable()
	--
end

function MenuElements.ResultSinglePlayerScores:Disable()
	--
end