MenuElements.SpecialMove = class(function(self, Panel, Template, Name)
	self.Item = MenuItem(Template)
	self.Panel = Panel
	self.Name = Name
	self.Enabled = true
	self.Hidden = true

	--self.Item = self.Panel:AddItem(Template)

	-- Init
	self.NameItem = self.Item:GetChild("Name")
	--self.NameItemFlash = self.Item:GetChild("NameFlash")
	
	self:SetText(translate(self.Name))
	
	self.Color = Yellow
	self.Color_Hidden = White
end)

function MenuElements.SpecialMove:DelItem(Index)
	--self.Panel:DelItem(self.Item)
end

function MenuElements.SpecialMove:Activate()
	--
end

function MenuElements.SpecialMove:Deactivate()
	--
end

function MenuElements.SpecialMove:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		--
	end
end

function MenuElements.SpecialMove:Disable()
	if (self.Enabled) then
		self.Enabled = false
		--
	end
end

function MenuElements.SpecialMove:SetText(Text)
	if (self.Hidden) then
		self.NameItem:SetText(Translate("menu_LOCKED"))
	else
		self.NameItem:SetText(Text)
		--self.NameItemFlash:SetText(Text)
	end
end

function  MenuElements.SpecialMove:UpdateText(Text)
	if (Text ~= nil) then
		self.Name = Text
	end
	
	self:SetText(translate(self.Name))
end

function  MenuElements.SpecialMove:UpdateTextColor(Color)
	if (Color ~= nil) then
		self.Color = Color
	end
	
	if (self.Hidden) then
		self.NameItem:SetColor(self.Color_Hidden)
	else
		self.NameItem:SetColor(self.Color)
	end
end

function MenuElements.SpecialMove:HideText()
	if (not self.Hidden) then
		self.Hidden = true
		
		self:UpdateText()
		self:UpdateTextColor()
	end
end

function MenuElements.SpecialMove:ShowText()
	if (self.Hidden) then
		self.Hidden = false
		
		self:UpdateText()
		self:UpdateTextColor()
	end
end
-- =========
