FreeGoodsMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	CheckOnlineProgress()
	
	AnalyticsSendScreenName("FreeCoinsMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("FreeGoodsMenu", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\FreeGoodsButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		--[[ self.FreeGoodsRateButton = self.Items:AddItem(self.ItemsPanel, MenuElements.LabelFreeGoods(self.Items, "Elements\\FreeGoodsButtonNoCash.dcMenu", "menu_freegoods_rate", VirtualCoins.RateAmount))
		if (VirtualCoins.IsRated) then
			self.FreeGoodsRateButton:Disable()
		end
		
		self.FreeGoodsRateButton.OnReleased = function()
			self.FreeGoodsRateButton.OnReleased = nil
			
			if (GetPlatform() == "Win32") then
				openwebsite("http://play.google.com/store/apps/details?id=com.gamemill.monsterjam")
			elseif (GetPlatform() == "Android") then
				openwebsite("market://details?id=com.gamemill.monsterjam")
			elseif (GetPlatform() == "IOS") then
				openwebsite("itms-apps://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=781596959&onlyLatestVersion=true&pageNumber=0&sortOrdering=1&type=Purple+Software")
			end
			
			GameThread:Spawn(function(Thread)
				GameThread:Sleep(1.5)
				
				self.FreeGoodsRateButton:Disable()
				--VirtualCoins:AddCoinCount(VirtualCoins.RateAmount)	--Google Rate mag niet meer beloond worden?
				--VirtualCoins:SendCollectedCoinsStats("RateGame", VirtualCoins.RateAmount, 0)
				VirtualCoins.IsRated = true
				WriteGameSettings()
			end)
		end ]]
		
		self.FreeGoodsLikeDevButton = self.Items:AddItem(self.ItemsPanel, MenuElements.LabelFreeGoods(self.Items, self.ButtonTemplate, "menu_freegoods_LikeDev", VirtualCoins.LikeAmount_Developer))
		if (VirtualCoins.IsLiked_Developer) then
			self.FreeGoodsLikeDevButton:Disable()
		end
		self.FreeGoodsLikeDevButton.OnReleased = function()
			self.FreeGoodsLikeDevButton.OnReleased = nil
			
			if (GetPlatform() == "Win32") then
				openwebsite("http://www.facebook.com/Team6GameStudios")
			elseif (GetPlatform() == "Android" or GetPlatform() == "IOS") then
				openwebsite("http://m.facebook.com/Team6GameStudios")
			end
			
			GameThread:Spawn(function(Thread)
				GameThread:Sleep(1.5)
				
				self.FreeGoodsLikeDevButton:Disable()
				VirtualCoins:AddCoinCount(VirtualCoins.LikeAmount_Developer)
				VirtualCoins:SendCollectedCoinsStats("LikeDev", VirtualCoins.LikeAmount_Developer, 0)
				VirtualCoins.IsLiked_Developer = true
				WriteGameSettings()
			end)
		end

		self.FreeGoodsLikeGameButton = self.Items:AddItem(self.ItemsPanel, MenuElements.LabelFreeGoods(self.Items, self.ButtonTemplate, "menu_freegoods_LikeGame", VirtualCoins.LikeAmount_Game))
		if (VirtualCoins.IsLiked_Game) then
			self.FreeGoodsLikeGameButton:Disable()
		end
		self.FreeGoodsLikeGameButton.OnReleased = function()
			self.FreeGoodsLikeGameButton.OnReleased = nil
			
			if (GetPlatform() == "Win32") then
				openwebsite("http://www.facebook.com/mjonline")
			elseif (GetPlatform() == "Android" or GetPlatform() == "IOS") then
				openwebsite("http://m.facebook.com/mjonline")
			end
			
			GameThread:Spawn(function(Thread)
				GameThread:Sleep(1.5)
				
				self.FreeGoodsLikeGameButton:Disable()
				VirtualCoins:AddCoinCount(VirtualCoins.LikeAmount_Game)
				VirtualCoins:SendCollectedCoinsStats("LikeGame", VirtualCoins.LikeAmount_Game, 0)
				VirtualCoins.IsLiked_Game = true
				WriteGameSettings()
			end)
		end
		
		self.FreeGoodsVisitHomePageButton = self.Items:AddItem(self.ItemsPanel, MenuElements.LabelFreeGoods(self.Items, self.ButtonTemplate, "menu_freegoods_VisitHomePage", VirtualCoins.VisitAmount_Website))
		if (VirtualCoins.IsVisited_Website) then
			--self.FreeGoodsVisitHomePageButton:Disable()
			self.FreeGoodsVisitHomePageButton:HideCoinBackground()
		end
		self.FreeGoodsVisitHomePageButton.OnReleased = function()
			--self.FreeGoodsVisitHomePageButton.OnReleased = nil
			
			if (GetPlatform() == "Win32") then
				openwebsite("http://www.monsterjam.com/")
			elseif (GetPlatform() == "Android" or GetPlatform() == "IOS") then
				openwebsite("http://www.monsterjam.com/")
			end
			
			if (not VirtualCoins.IsVisited_Website) then
				GameThread:Spawn(function(Thread)
					GameThread:Sleep(1.5)
					
					--self.FreeGoodsVisitHomePageButton:Disable()
					self.FreeGoodsVisitHomePageButton:HideCoinBackground()
					VirtualCoins:AddCoinCount(VirtualCoins.VisitAmount_Website)
					VirtualCoins:SendCollectedCoinsStats("VisitWebsite", VirtualCoins.VisitAmount_Website, 0)
					VirtualCoins.IsVisited_Website = true
					WriteGameSettings()
				end)
			end
		end
		
		if(FBManager:IsLoginValid()) then
		--if (false) then
			--self.FriendsMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButtonFB.dcMenu", "menu_friends"))
			self.FriendsMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.LabelFreeGoods(self.Items, "Elements\\FreeGoodsButtonFacebook.dcMenu", "menu_friends", 0, true))
			self.FriendsMenu.OnReleased = function()
				self:Goto(FriendsMenu)
			end
		end
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end)
end)

function FreeGoodsMenu:Goto(Target)
	ActiveMenu = Target(FreeGoodsMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function FreeGoodsMenu:Active()
	return ActiveMenu == self
end

function FreeGoodsMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = FreeGoodsMenu(PreviousMenu)
end

function FreeGoodsMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function FreeGoodsMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function FreeGoodsMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function FreeGoodsMenu:Back()
	self:Goto(MainMenu)
end