None = 0
Linear = 1
Sine = 2
QuarterSine = 3
HalfSine = 4
FullSine = 5

Top = 0
Left = 0
Center = 0.5
Right = 1
Bottom = 1

-- ============================
-- ALIGN CONSTANTS
-- N=North, S=South, E=East, W=West
ALIGN_NS			= 1
ALIGN_NE			= 2
ALIGN_NW			= 3
ALIGN_SN			= 4
ALIGN_SE			= 5
ALIGN_SW			= 6
ALIGN_EN			= 7
ALIGN_ES			= 8
ALIGN_EW			= 9
ALIGN_WN			= 10
ALIGN_WS			= 11
ALIGN_WE			= 12
-- ============================


-- ============================
-- EASING CONSTANTS
EASE_LINEAR 		= 1

EASE_IN_SINE		= 2
EASE_OUT_SINE		= 3
EASE_INOUT_SINE		= 4
EASE_OUTIN_SINE		= 5

EASE_IN_QUAD		= 6
EASE_OUT_QUAD		= 7
EASE_INOUT_QUAD		= 8
EASE_OUTIN_QUAD		= 9

EASE_IN_CUBIC		= 10
EASE_OUT_CUBIC		= 11
EASE_INOUT_CUBIC	= 12
EASE_OUTIN_CUBIC	= 13

EASE_IN_QUART		= 14
EASE_OUT_QUART		= 15
EASE_INOUT_QUART	= 16
EASE_OUTIN_QUART	= 17

EASE_IN_QUINT		= 18
EASE_OUT_QUINT		= 19
EASE_INOUT_QUINT	= 20
EASE_OUTIN_QUINT	= 21

EASE_IN_EXPO		= 22
EASE_OUT_EXPO		= 23
EASE_INOUT_EXPO		= 24
EASE_OUTIN_EXPO		= 25

EASE_IN_CIRC		= 26
EASE_OUT_CIRC		= 27
EASE_INOUT_CIRC		= 28
EASE_OUTIN_CIRC		= 29

EASE_IN_ELASTIC 	= 30	-- 2 extra parameters (Amplitude, Period)
EASE_OUT_ELASTIC 	= 31	-- 2 extra parameters (Amplitude, Period)
EASE_INOUT_ELASTIC 	= 32	-- 2 extra parameters (Amplitude, Period)
EASE_OUTIN_ELASTIC 	= 33	-- 2 extra parameters (Amplitude, Period)

EASE_IN_BACK 		= 34
EASE_OUT_BACK 		= 35
EASE_INOUT_BACK 	= 36
EASE_OUTIN_BACK 	= 37

EASE_IN_BOUNCE 		= 38
EASE_OUT_BOUNCE 	= 39
EASE_INOUT_BOUNCE 	= 40
EASE_OUTIN_BOUNCE 	= 41

EASE_CUSTOM_BEZIER 	= 42	-- 4 extra parameters (ControlPoint1_X, ControlPoint1_Y, ControlPoint2_X, ControlPoint2_Y)
-- ============================

CENTER = Center
LEFT = Left
RIGHT = Right
TOP = Top
BOTTOM = Bottom