RaceResultEarnMonsterJamCoin = class(function(self, PreviousMenu, LastHighscorePosted )
	self.PreviousMenu = PreviousMenu
	self.LastHighscorePosted = LastHighscorePosted
	
	-- gooi menu er op
	self.Menu = PushMenu("RaceResultEarnMonsterJamCoin")

	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)

	self.HighscoreItems = self.Menu:GetChild("HighscoreItems")
	
	self.EarnMonsterJam_Title = self.Menu:GetChild("EarnMonsterJam_Title")
	self.EarnMonsterJam_Title2 = self.Menu:GetChild("EarnMonsterJam_Title2")
	
	-- Fade in items
	self.Main:SetColorImmediate(White)
	
	-- Panels leegmaken en lijst aanmaken

	local Items = NewItemList(self, LeftButtons, RightButtons)
	self.Items = Items
	
	self.BackButtonPanel = self.Menu:GetChild("BackButton")
	self.ProceedButtonPanel = self.Menu:GetChild("ProceedButton")

	self.BackButtonPanel:Clear()
	self.ProceedButtonPanel:Clear()
	
	self.BackButton = Items:AddItem(self.BackButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonBack.dcMenu", "button_restart"))
	self.BackButton.OnReleased = function()
		CutsceneBars = nil
		self.Menu:SetColor(Invisible)
		
		if (EndRaceCameraThread ~= nil) then
			PhysicsThread:Stop(EndRaceCameraThread)
			
			var('modelerp', 10000)
		end
		
		GameThread:Spawn(function()
			self.FadeScreen = self.Menu:GetChild("FadeScreen")
			self.FadeScreen:SetSize(9999, 9999)
			self.FadeScreen:SetColorFade(1, 2)
			self.FadeScreen:SetColorImmediate(color(0,0,0,0))
			self.FadeScreen:SetColor(Black)
			
			GameThread:Wait(1)
		
			-- if (ActiveMission ~= nil) then
				-- ActiveMission:Destroy()
				-- ActiveMission = nil
			-- end
			
			ClearMenuStack()
			ActiveMenu = nil
			CutsceneBars = nil
		
			var("IntPause", 0)
			reloadscript()
		end)
	end
	
	self.Proceed = Items:AddItem(self.ProceedButtonPanel, MenuElements.Label(Items, "Elements\\MenuButtonProceed.dcMenu", "button_proceed"))
	self.Proceed.OnReleased = function()
	
		self.Main:SetColorImmediate(Invisible)
		ActiveMenu = RaceResultHighScore(nil, self.LastHighscorePosted)
		
		-- mischien moet dit later weer aan? je weet maar nooit...
		--[[GameThread:Spawn(function()
			-- Eerst menu weg
			CutsceneBars = nil
			self.Menu:SetColor(Invisible)
			ClearMenuStack()
			ActiveMenu = nil
			CutsceneBars = nil
			HUD = nil

			-- Dan pauze uit
			var("IntPause", 0)

			-- Dan de prepare functie zetten
			PrepareScript = function()
				ActiveMission = MenuMission()
				
				ActiveMenu = Garage(nil)
			end

			-- En dan pas laden
			loadscript("Menu")
		end)]]
	end
	self.Proceed:Flash(1, true, true)
	
	-- add gear
	VirtualCoins:AddGoloCoinCount(1)
	MJCoinEarned = true
	WriteGameSettings()
	
	local ButtonOffset = 50
	local ProceedButtonOffset = #self.Items.Items - 1
	self.Items:Format(ALIGN_NS, SafeFrameOffsetX, 0, -ButtonOffset, 0, Left, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items - 1)
	self.Items:FormatTween(ALIGN_NS, 0, 0, -ButtonOffset, 0, Right, Bottom, Right, Bottom, ProceedButtonOffset, #self.Items.Items - 1)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
end)

function RaceResultEarnMonsterJamCoin:Goto(Target)
	ActiveMenu = Target(RaceResultEarnMonsterJamCoin)

	self.Main:SetColor(Invisible)
end

function RaceResultEarnMonsterJamCoin:Active()
	return ActiveMenu == self
end

function RaceResultEarnMonsterJamCoin:Refresh()
	ActiveMenu = RaceResultEarnMonsterJamCoin(self.PreviousMenu, self.LastHighscorePosted)
end