HUD = nil

StrapReminder = class(function(self)
	-- gooi menu er op
	var("VirtualRTx", 832)
	var("VirtualRTy", 456)
	
	self.Menu = pushmenu("StrapReminder", 0)

	self.Logo1 = self.Menu:GetChild("Logo1")
	self.Logo2 = self.Menu:GetChild("Logo2")
	self.FadeScreen = self.Menu:GetChild("FadeScreen")
	
	local Language = getsystemlanguage()
	self.Logo1:SetImage(StrapATexture)
	self.Logo2:SetImage(StrapBTexture)
	
	self.InputEnabled = false
	self.LoadGameStarted = false
	PhysicsThread:Spawn(function(Thread)
		self.FadeScreen:SetColorFade(1, 2)
		self.FadeScreen:SetColor(color(0, 0, 0, 0))

		GameThread:Sleep(1.5 * 60)
		self.InputEnabled = true
		GameThread:Sleep(4.0 * 60)
	
		self.Logo2:SetColorFade(1, 2)
		self.Logo2:SetColor(color(1, 1, 1, 1))
		GameThread:Sleep(5 * 60)

		self.Logo2:SetColorFade(1, 2)
		self.Logo2:SetColor(color(1, 1, 1, 0))
		GameThread:Sleep(5 * 60)

		self.Logo2:SetColorFade(1, 2)
		self.Logo2:SetColor(color(1, 1, 1, 1))
		GameThread:Sleep(5 * 60)
		
		DelKeyListeners(self.Listeners)
		self.Listeners = nil
		self:LoadGame()
	end)
	
	local ShortKeyNameList = {"LEFT", "RIGHT", "DOWN", "UP", "A", "B", "PLUS", "MINUS", "1", "2"}
	local KeyList = {}
	for i = 0, 3 do
		for j, ShortKeyName in ipairs(ShortKeyNameList) do
			local KeyName = "DCK_WII" .. i .. "_" .. ShortKeyName
			table.insert(KeyList, KeyName)
		end
	end
	table.insert(KeyList, "DCK_SPACE")
	
	self.Listeners = AddKeyListeners(KeyList, "Down", function(Listener)
		PhysicsThread:Spawn(function(Thread)
			DelKeyListeners(self.Listeners)
			self.Listeners = nil
			while (self.InputEnabled == false) do
				GameThread:Sleep(1)
			end
			self:LoadGame()
		end)
	end)
end)

function StrapReminder:LoadGame()
	if self.LoadGameStarted == false then
		self.LoadGameStarted = true
	
		self.FadeScreen:SetColorFade(1, 2)
		self.FadeScreen:SetColor(color(0, 0, 0, 1))
		GameThread:Sleep(0.6 * 60)
		
		GameThread:Spawn(function(Thread)
			SetVirtualRT(GetResolution())
			LoadGame()
		end)
	end
	
end

function StrapReminder:Refresh()
	ActiveMenu = StrapReminder()
end