-- text item
RankStar = class(function(self, Panel, Template)
	self.Panel = Panel
	self.Item = Panel:AddItem(Template)
	
	self.RotatingStarsPanel = self.Item:GetChild("RotatingStarsPanel")
	self.Star = self.Item:GetChild("Star")
	self.StarFlash = self.Item:GetChild("StarFlash")

	self.RotatingStar1 = self.Item:GetChild("RotatingStar1")
	self.RotatingStar2 = self.Item:GetChild("RotatingStar2")
	self.RotatingStar3 = self.Item:GetChild("RotatingStar3")

	self.RotatingStar1:SetOffset(64, 70)
	self.RotatingStar2:SetOffset(64, 70)
	self.RotatingStar3:SetOffset(64, 70)

	-- Init
	self.RotatingStarsPanel:SetColorFade(1, 0.25)
	self.StarFlash:SetColorFade(1, 1)
	self.Star:SetColorImmediate(Invisible)
	self.RotatingStarsPanel:SetColorImmediate(Invisible)

end)

function RankStar:Left()
	--
end

function RankStar:Right()
	--
end

function RankStar:Activate(First)
	PhysicsThread:Spawn(function()
		self.Star:SetColorImmediate(White)
	
		PhysicsThread:Sleep(0.5)
		
		self.StarFlash:SetColor(color(1, 1, 1, 1))
		self.StarFlash:SetColorFade(1,6)
		
		self.RotatingStarsPanel:SetColorImmediate(color(1, 1, 1, 1))
		self.RotatingStarsPanel:SetColor(color(1, 1, 1, 0))
		
		PhysicsThread:Sleep(0.25)
		
		self.StarFlash:SetColor(color(1, 1, 1, 0))
		self.StarFlash:SetColorFade(1,1)
	end)
end

function RankStar:Deactivate()
	--
end

function RankStar:DelItem(Index)
	self.Panel:DelItem(Index)
end