UpgradesMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	CheckOnlineProgress()
	
	AnalyticsSendScreenName("PowerupMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("UpgradesMenu", nil, function()
	
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.Items_Upgrades = self.Menu:GetChild("Items_Upgrades")
		self.Items_Upgrades_Panel = self.Menu:GetChild("Items_Upgrades_Panel")
		self.UpgradeImage = self.Menu:GetChild("UpgradeImage")
		self.InstallText = self.Menu:GetChild("InstallText")
		
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		self.UnlockButtonPanelLeft = self.Menu:GetChild("UnlockButtonPanelLeft")
		self.UnlockButtonPanelRight = self.Menu:GetChild("UnlockButtonPanelRight")
		self.UnlockButtonPanelCenter = self.Menu:GetChild("UnlockButtonPanelCenter")
		self.Price_Or_Text = self.Menu:GetChild("Price_Or_Text")
		
		self.InstalledText = self.Menu:GetChild("InstalledText")
		
		self.UnlockButtonPanelLeft:Clear()
		self.UnlockButtonPanelRight:Clear()
		self.UnlockButtonPanelCenter:Clear()
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		--self.InstallText:SetColorImmediate(Invisible)
		ActiveForeground:HideInfoText()
		self.Items = NewItemList(self, nil, nil)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.ItemList_Upgrades = NewItemList(self, nil, nil)
		--self.ItemList_Upgrades.Wrapping = true
		self.ItemList_Upgrades.Panel = self.Items_Upgrades
		self.ItemList_Upgrades.Panel:Clear()
		self.ItemList_Upgrades.TotalNormalButtons = 0
		
		self.InstantRepairUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "powerup_repair_low"))
		self.SuperNitroUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "powerup_nitro_low"))
		self.UltraDestroyerBumpersUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "powerup_bumpers_low"))
		self.SuperJumpUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "powerup_jump_low"))
		--self.WingsUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "Wings"))
		self.FireworksUpgrade = self.ItemList_Upgrades:AddItem(self.ItemList_Upgrades.Panel, MenuElements.Label(self.ItemList_Upgrades, self.ButtonTemplate, "powerup_fireworks_low"))
		
		self.ItemList_Upgrades:SetSelection(self.InstantRepairUpgrade)
		self.ItemList_Upgrades.TotalNormalButtons = #self.ItemList_Upgrades.Items
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		-- Add proceed button
		self.TotalProceedButtons = 0					-- Hoeveel proceed buttons zitten er nu in de lijst? handig te weten voor de formatting!
		self.ProceedButtonGold = self.Items:AddItem(self.UnlockButtonPanelLeft, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
		self.ProceedButtonGear = self.Items:AddItem(self.UnlockButtonPanelRight, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
		self.ProceedButtonBig = self.Items:AddItem(self.UnlockButtonPanelCenter, MenuElements.LabelGarageUnlock(self.Items, "Elements\\Garage_Unlock_Coins_Button.dcMenu", "button_unlock", "0.00"))
		--self.ProceedButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonProceed.dcMenu", "button_install"))
		self.TotalProceedButtons = self.TotalProceedButtons + 3
		--table.insert(self.MenuDelItem_Queue, self.ProceedButton)
		self.ProceedButtonGold.OnReleased = function()
			self:BuyFunction(false)
		end
		
		self.ProceedButtonGear.OnReleased = function()
			self:BuyFunction(true)
		end
		
		self.ProceedButtonBig:Disable()
		self.ProceedButtonBig.Panel:SetColorImmediate(Invisible)
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		-- Format proceed button
		self.Items:Format(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons + self.TotalBackButtons, self.TotalNormalButtons + self.TotalBackButtons + self.TotalProceedButtons)
		
		--self.Items:SetSelection(self.ProceedButtonGold)	
		
		ActiveGameMode:LoadTextures()
		
		self:SetItemlistSize()
		self:UpdateTheUpgrades()
		
		local SpaceY = 16
		self.ItemList_Upgrades:Format(ALIGN_NS, 0, 0, 0, SpaceY, Center, 0, Center, 0)
		
		local ItemsPanel = self.ItemList_Upgrades.Panel
		local ClickArea = self.Items_Upgrades_Panel
		if (ItemsPanel:GetHeight() > ClickArea:GetHeight()) then
			local ButtonSize = 128 + 16
			local ListSpace = ActiveForeground:GetContentHeight()
			self.ItemList_Upgrades:EnableSliding(ItemsPanel, ClickArea, ButtonSize, ListSpace, false, nil, nil, nil)
		end
		self.ItemList_Upgrades.Wrapping = false
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end 
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if(self.Items:GetSelection().OnReleased ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end)
end)

function UpgradesMenu:SetPowerUp(UpgradeItem)
	local Item = self:GetCurrentUpgradeItem()
	if (Item ~= UpgradeItem) then
		return
	end
	
	-- if (Item.EndTime > 0) then
		-- local Time = os.date("!%X",(Item.EndTime - os.time()))
		-- self:UpdateDescriptionText(Translate(Item.Description) .. " Time left: " .. Time)
	-- else
		self:UpdateDescriptionText(Translate(Item.Description))
	-- end
end

function UpgradesMenu:UpdateTheUpgrades()
	self:UpdateButtons()
end

function UpgradesMenu:BuyFunction(useGears)
	if (self.ItemList_Upgrades ~= nil) then		
		local UpgradeItem = self:GetCurrentUpgradeItem()
		
		if (UpgradeItem ~= nil) then
			print("^1 UPGRADE AANKOOP")
			
			--Buy via GoloCoins?
			--if (UpgradeItem.GetGoloPrice ~= nil and UpgradeItem:GetGoloPrice(ActiveGameMode:GetSelectedCar()) ~= nil) then
			if (useGears) then
				-- met gears betalen
				local CoinsPrice = UpgradeItem:GetGoloPrice()
				local genoegcredits = (VirtualCoins:GetGoloCoinCount() >= CoinsPrice)
				if not genoegcredits then
					local CreditsNeeded = (CoinsPrice - VirtualCoins:GetGoloCoinCount())
					ShowConfirm_NoGolo(CreditsNeeded, UpgradesMenu)
				else
					ShowConfirm_BuyPowerupItem(UpgradeItem, CoinsPrice, true)
				end
			else
				-- met money betalen
				local CoinsPrice = UpgradeItem:GetPrice(ActiveGameMode:GetSelectedCar())
				local genoegcredits = (VirtualCoins:GetCoinCount() >= CoinsPrice)
				if not genoegcredits then
					local CreditsNeeded = (CoinsPrice - VirtualCoins:GetCoinCount())
					ShowConfirm_NoGold(CreditsNeeded, UpgradesMenu)
				else
					ShowConfirm_BuyPowerupItem(UpgradeItem, CoinsPrice)
				end
			end
		else
			print("^1Failed to Buy!")
		end
	end
end

function UpgradesMenu:Goto(Target)
	ActiveMenu = Target(UpgradesMenu)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
	
	self:UpdateDescriptionText(nil)
end

function UpgradesMenu:Active()
	return ActiveMenu == self
end

function UpgradesMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = UpgradesMenu(PreviousMenu)
end

function UpgradesMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	GameThread:Spawn(function()
		if (self.ItemList_Upgrades ~= nil) then
			for i, Item in ipairs(self.ItemList_Upgrades.Items) do
				--print("Show; ^2" .. tostring(Item.Name))
				Item:Enable()
			end
			
			if (self.LastSelectedItem ~= nil) then
				self.ItemList_Upgrades:SetSelection(self.LastSelectedItem)
				self.LastSelectedItem:Activate()
			end
		end
	end)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function UpgradesMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	if (self.ItemList_Upgrades ~= nil) then
		self.LastSelectedItem = self.ItemList_Upgrades:GetSelection()
	
		for i, Item in ipairs(self.ItemList_Upgrades.Items) do
			--print("Hide; ^2" .. tostring(Item.Name))
			Item:Disable()
		end
	end
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function UpgradesMenu:GetCurrentUpgradeItem()
	local UpgradeItem = nil
	
	if (self.ItemList_Upgrades ~= nil) then
		local SelectedUpgrade = self.ItemList_Upgrades:GetSelection() 
		
		if (SelectedUpgrade == self.InstantRepairUpgrade) then
			UpgradeItem = Powerup_InstantRepair
		elseif (SelectedUpgrade == self.SuperNitroUpgrade) then
			UpgradeItem = Powerup_SuperNitro
		elseif (SelectedUpgrade == self.UltraDestroyerBumpersUpgrade) then
			UpgradeItem = Powerup_UltraBumpers
		elseif (SelectedUpgrade == self.SuperJumpUpgrade) then
			UpgradeItem = Powerup_SuperJump
		elseif (SelectedUpgrade == self.FireworksUpgrade) then
			UpgradeItem = Powerup_Fireworks
		end
	end
	
	return UpgradeItem
end


function UpgradesMenu:UpdateButtons()
	local UpgradeItem = self:GetCurrentUpgradeItem()
	
	if (UpgradeItem.Texture ~= nil) then
		self.UpgradeImage:SetImage(UpgradeItem.Texture)
	end
	
	local descriptionText = UpgradeItem.Description
	--self:UpdateDescriptionText(Translate(descriptionText))
	self:SetPowerUp(UpgradeItem)
	
	if (UpgradeItem ~= nil) then
		if(self.ProceedButtonGold ~= nil) then
			self.ProceedButtonGold:SetText(Translate("button_unlock"), tostring(UpgradeItem:GetPrice()), false)
		end
		
		if(self.ProceedButtonGear ~= nil) then
			self.ProceedButtonGear:SetText(Translate("button_unlock"), tostring(UpgradeItem:GetGoloPrice()), true)
		end
		
		if (UpgradeItem:Available()) then
			self.InstallText:SetText(Translate("powerup_title_notbought"))
			self.InstalledText:SetColor(Invisible)
			
			if(self.ProceedButtonGold ~= nil) then
				self.ProceedButtonGold:Enable()
				self.ProceedButtonGold.Panel:SetColor(White)
				--self.Items:SetSelection(self.ProceedButtonGold)
			end
			
			if(self.ProceedButtonGear ~= nil) then
				self.ProceedButtonGear:Enable()
				self.ProceedButtonGear.Panel:SetColor(White)
			end
			self.Price_Or_Text:SetColor(White)			
		else
			self.InstallText:SetText(Translate("powerup_title_bought"))
			self.InstalledText:SetColor(White)
			
			if(self.ProceedButtonGear ~= nil) then
				self.ProceedButtonGear:Disable()
				self.ProceedButtonGear.Panel:SetColor(Invisible)
			end
			if(self.ProceedButtonGold ~= nil) then
				self.ProceedButtonGold:Disable()
				--self.ProceedButtonGold:SetText("", "", nil)
				self.ProceedButtonGold.Panel:SetColor(Invisible)	
			end
			self.Price_Or_Text:SetColor(Invisible)
		end
	else
		print("^1Failed to update buttons!")
	end
end

function UpgradesMenu:UpdateDescriptionText(Text)
	if (ActiveForeground ~= nil) then
		if (ActiveForeground.SetDescriptionText ~= nil and ActiveForeground.ShowDescriptionText ~= nil and ActiveForeground.HideDescriptionText ~= nil) then
			ActiveForeground:ShowDescriptionText()
			
			if (Text ~= nil) then
				ActiveForeground:SetDescriptionText(Text)
			else
				ActiveForeground:HideDescriptionText()
			end
		end
	end
end

function UpgradesMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function UpgradesMenu:Back()
	self:Goto(MainMenu)
end

function UpgradesMenu:SetItemlistSize()
	self.Items_Image_Panel = self.Menu:GetChild("Items_Image_Panel")
	self.ButtonsPanel = self.Menu:GetChild("ButtonsPanel")
	self.Items_Upgrades_Panel = self.Menu:GetChild("Items_Upgrades_Panel")

	local ContentHeight = ActiveForeground:GetContentHeight()
	print("ContentHeight =" .. ContentHeight)

	local ContentWidth = SafeFrameWidth - self.Items_Upgrades_Panel:GetWidth()
	print("ContentWidth =" .. ContentWidth)
	
	local ScreenWidth = getvar("VirtualRTx")	
	local ImageX = (ScreenWidth - self.Items_Upgrades_Panel:GetWidth()) / 2 - 75
	
	self.ButtonsPanel:SetSize(ContentWidth - 240 * 1.69, ContentHeight - 190 * 0.59)
	self.ButtonsPanel:SetPos(ImageX, -100)
	
	local ImageHeight = ContentHeight - self.ButtonsPanel:GetHeight() - 80
	local ImageWidth = (ImageHeight / 2) * 3
	
	self.UpgradeImage:SetSize(ImageWidth, ImageHeight)
	self.Items_Image_Panel:SetPos(ImageX, -4)
	
	local TitleBarHeight = ActiveForeground:GetTitlebarHeight()
	local ContentHeight = ActiveForeground:GetContentHeight()

	self.Items_Upgrades_Panel:SetSize(350, ContentHeight) -- passend maken
	self.Items_Upgrades_Panel:SetPos(0, TitleBarHeight - 20) -- op juiste plek zetten
	--self.CategoryPanel:SetPos(0, TitleBarHeight + 24) -- op juiste plek zetten
end