MenuElementCache = class(function(self, Wildcard)
	self.Elements = {}
	
	GetFS():FindCallback("Menu\\Elements\\*.dcMenu", function(FileName)
		local Element = MenuItem(FileName);
		
		self.Elements[string.upper(FileName)] = Element
	end)
	
	GetFS():FindCallback("Menu\\HUD\\Elements\\*.dcMenu", function(FileName)
		local Element = MenuItem(FileName);
		
		self.Elements[string.upper(FileName)] = Element
	end)

	-- Lelijk maargoed. Eens kijken of het werkt
	MenuItem = function(...)
		return MenuCache:Get(...)
	end
end)

function MenuElementCache:Get(FileName)
	FileName = "MENU\\" .. string.upper(FileName)

	local Element = self.Elements[FileName];
	
	--print(FileName .. " komt door de cache heen")
	
	if (Element == nil) then
		print("Trying to get non-existent element " .. FileName)
		
--MessageBox(FileName. FileName, FileName);
		
		return FileName
	end
	
	return Element:Clone()
end

if (not Win32()) then	--Uitzetten op Win32 voor development
	MenuCache = MenuElementCache()
end