PowerUpItem = class(function(self, Name, ImageName, Locked, Bought)
	self.Name = Name
	self.ImageName = ImageName
	self.CoinsPrice = GetPowerUp(self.Name, "Gold") 
	self.GoloCoinsPrice = GetPowerUp(self.Name, "MJ")
	self.Description = (self.Name .. "_description")
	self.Locked = Locked
	self.Bought = Bought
	self.Texture = nil
	-- self.EndTime = 0
	-- self.TimerThread = nil
	table.insert(PowerUpItems, self)
end)

-- function PowerUpItem:UpdatePowerUp()
	-- if (ActiveMenu ~= nil and ActiveMenu:is_a(UpgradesMenu)) then
		-- ActiveMenu:SetPowerUp(self)
	-- end
	
	-- if (self.EndTime <= os.time()) then
		-- self.Bought = false
		-- self.EndTime = 0
		-- WriteGameSettings()
		-- GameThread:Stop(self.TimerThread)
		-- self.TimerThread = nil
	-- end
-- end

function PowerUpItem:GetPrice()
	return self.CoinsPrice
end

function PowerUpItem:GetGoloPrice()
	return self.GoloCoinsPrice
end

function PowerUpItem:Available()
	if (not self.Locked and not self.Bought) then
		return true
	else
		return false
	end
end

function PowerUpItem:Buy()
	self.Bought = true
	-- self.EndTime = os.time() + (GetPowerUp(self.Name, "DayLimit") * 86400)
	WriteGameSettings()
	-- self:SetUpdate()
end

function PowerUpItem:SetUpdate()
	-- if(self.TimerThread ~= nil) then
		-- GameThread:Stop(self.TimerThread)
		-- self.TimerThread = nil
	-- end
	
	if(self.Bought) then
		if (ActiveMenu ~= nil and ActiveMenu:is_a(UpgradesMenu)) then
			ActiveMenu:SetPowerUp(self)
		end
		
		-- self.TimerThread = GameThread:Spawn(function()
			-- while (true) do
				-- self:UpdatePowerUp()
				-- GameThread:Wait(1)
			-- end
		-- end)
	end
end

function PowerUpItem:LoadTextures()
	self.Texture = texture(self.ImageName)
end

function PowerUpItem:UnloadTextures()
	self.Texture = nil
end

function PowerUpItem:Read(File, Version)
	self.Bought = File:ReadBoolean()
	-- self.EndTime = File:ReadInt()
	self:SetUpdate()
end

function PowerUpItem:Write(File)
	File:WriteBoolean(self.Bought)
	-- File:WriteInt(self.EndTime)
end

PowerUpItems = {}
Powerup_InstantRepair = PowerUpItem("powerup_repair", "Upgrades\\Powerups\\MJ_PowerUp_Repair.dct", false, false)
Powerup_SuperNitro = PowerUpItem("powerup_nitro", "Upgrades\\Powerups\\MJ_PowerUp_TurboBoost.dct", false, false)
Powerup_UltraBumpers = PowerUpItem("powerup_bumpers", "Upgrades\\Powerups\\MJ_PowerUp_Destruct.dct", false, false)
Powerup_SuperJump = PowerUpItem("powerup_jump", "Upgrades\\Powerups\\MJ_PowerUp_SuperJump.dct", false, false)
Powerup_Fireworks = PowerUpItem("powerup_fireworks", "Upgrades\\Powerups\\MJ_PowerUp_Fireworks.dct", false, false)

function PowerUps_Read(File, Version)
	local PowerupItemsCount = File:ReadInt()
	for i = 1, PowerupItemsCount do
		PowerUpItems[i]:Read(File, Version)
	end
end

function PowerUps_Write(File)
	File:WriteInt(#PowerUpItems)
	for i = 1, #PowerUpItems do
		PowerUpItems[i]:Write(File, Version)
	end
end