StoppieStunt = class(BaseStunt, function(self)
	--self.ID = SCORE_STOPPIE
	self.ScreenName = "stunt_title_stoppie"
	self.ActivationDelay = 0.5
	self.DeactivationDelay = 1.0
	
	-- Set up the WheelsState that indicates we're doing a stoppie stunt
	local ActivationState = WheelsState()
	ActivationState.Wheels[0] = true
	ActivationState.Wheels[1] = true
	ActivationState.Wheels[2] = false
	ActivationState.Wheels[3] = false
	
	self:AddActivationState(ActivationState)
end)

function StoppieStunt:OnDeactivated()
	local Result = self:CreateResult()
	Result.Message = "Stoppie (" ..self.Duration .." sec)"
	
	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\Stoppie.wav")
end

function StoppieStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt
	--print(self.Player.Scores[self.ID])
end