ShocksUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.Shocks
	
	self.MenuUpgrade = self.Upgrader:GetMenuCarUpgrade("garage_airshocks")
	self:SetLevel(self.MenuUpgrade.CurrentLevel)
end)

function ShocksUpgrade:Apply(CarBuilder)
	local ErpDecreaseFactor = 0.03 -- -0.02 / 0.7
	local CfmDecreaseFactor = 0.04 -- -0.000002 / 0.00005
	
	-- Increases/decreased per level
	--local ErpIncrease = -0.02 -- Hoe diep de auto kan doorzakken op zijn wielen op impact. (minder = minder zakken)
	--local CfmIncrease = -0.000002 -- Bounciness wielen op impact (minder = minder bounciness). Default = 0.00005
	
	-- Tweak the supsension
	self:SetSuspension(CarBuilder, ErpDecreaseFactor, CfmDecreaseFactor)
	
	print("^2ShocksUpgrade applied (level " ..self.Level ..").")
end
function ShocksUpgrade:GetTerrainDamageReduction(Damage)
	local DamageReductionFactor = self.Level * 0.03 -- 3% damage reduction per level
	return DamageReductionFactor * Damage
end