-- Video config
PerformanceIndex = GetPerformanceIndex()

function DefaultVideoOptions()
	--[[ if (GetPlatform() == "3DS") then
        dofile("Lua\\VideoPresets\\N3DSPreset.lua")
        return
    end

    if (GetPlatform() == "IOS" or GetPlatform() == "Android") then
        dofile("Lua\\VideoPresets\\GLESPreset.lua")
        return
    end ]]--

	--[[ if (PerformanceIndex <= 0) then
		dofile("Lua\\VideoPresets\\VideoPreset2.lua")
		if (PerformanceIndex == "-1") then
			var("AutoConfig", 1)
		else
			var("AutoConfig", 0)
		end
	elseif (PerformanceIndex < 4.0) then
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset0.lua")
	elseif (PerformanceIndex < 4.5) then
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset1.lua")
	elseif (PerformanceIndex < 5.0) then
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset2.lua")
	elseif (PerformanceIndex < 5.5) then
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset3.lua")
	elseif (PerformanceIndex < 6.0) then
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset4.lua")
	else ]]--
		var("AutoConfig", 1)
		dofile("Lua\\VideoPresets\\VideoPreset5.lua")
	--end
end

function SetVideoOptions()
	Value = getvar("VideoPreset")
	
	if (Value == "verylow") then
		dofile("Lua\\VideoPresets\\VideoPreset0.lua")
	elseif (Value == "low") then
		dofile("Lua\\VideoPresets\\VideoPreset1.lua")
	elseif (Value == "medium") then
		dofile("Lua\\VideoPresets\\VideoPreset2.lua")
	elseif (Value == "high") then
		dofile("Lua\\VideoPresets\\VideoPreset3.lua")
	elseif (Value == "veryhigh") then
		dofile("Lua\\VideoPresets\\VideoPreset4.lua")
	elseif (Value == "ultra") then
		dofile("Lua\\VideoPresets\\VideoPreset5.lua")
	end
end

if (getvar("AutoConfig") ~= "1") then
	DefaultVideoOptions()
end