uniform sampler2D Tex0;

varying highp vec2 fTexCoord;

void main(){
    lowp vec4 Color = texture2D(Tex0, fTexCoord);

	// Degamma
	Color.r = pow(Color.r, 0.45);
	Color.g = pow(Color.g, 0.45);
	Color.b = pow(Color.b, 0.45);
	
	// Effect
	Color *= 2.0;
	
	// Gamma
	Color.r = pow(Color.r, 2.2);
	Color.g = pow(Color.g, 2.2);
	Color.b = pow(Color.b, 2.2);
	
    gl_FragColor = Color;
}