uniform vec4 World[3];

attribute vec2 Position;
attribute vec2 TexCoord0;

varying vec2 fTexCoord;

void main() {
    vec2 InputPos = Position;
    
    vec2 P;
    P.x = InputPos.x * World[0].x + InputPos.y * World[0].y + World[0].w;
    P.y = InputPos.x * World[1].x + InputPos.y * World[1].y + World[1].w;
   
    fTexCoord.x = TexCoord0.x;
	fTexCoord.y = TexCoord0.y;
    gl_Position = vec4(P, 0, 1);
}
