uniform sampler2D Tex0;

varying lowp vec4 fColor;
varying highp vec2 fTexCoord;

void main(){
    lowp vec4 Color = texture2D(Tex0, fTexCoord);
    
#ifdef WHITE
	Color.rgb = vec3(1.0, 1.0, 1.0);
#endif

#ifdef GREYSCALE
	Color.rgb = vec3(dot(Color.rgb, vec3(0.222, 0.707, 0.071)));
#endif

    gl_FragColor = Color * fColor;
}

