print("LOADING EXTRACONFIG.LUA")

var("CharacterForce", 1000)
var("AccelSensitivity", 0.8)
var("SteeringSensitivity", 1.0)
var("physicsstep", "0.7")

var("HorSensitivity", "3")
var("VerSensitivity", "3")

math.sign = function(x)
	if (x >= 0) then
		return 1
	else
		return -1
	end
end

function GetAccelerometerValues(Accel)
	local DeadZone = 0.05;--0.1
	local MaxSteeringAngle = 0.6
	local Power = 1.5

	-- Eerst normalizen
	Accel = Accel:Normalize()

	-- Stuurhoek
	local x = (-1.0 + math.abs(math.acos(Accel.x)) / (math.pi / 2)) * 2.0;

	
	if (x > DeadZone) then
		x = (x - DeadZone) / (MaxSteeringAngle - DeadZone)
	elseif (x < -DeadZone) then
		x = (x + DeadZone) / (MaxSteeringAngle - DeadZone)
	else
		x = 0
	end

	x = ClampMinMax(x, -1.0, 1.0)

	x = math.sign(x) * math.pow(math.abs(x), Power)

	--print(x)


	-- Y is hier niet van belang. Is alleen voor Flatout
	local y = (-1.0 + math.abs(math.acos(Accel.y)) / (math.pi / 2)) * 2.0;

	y = y + (math.pi / 4);

	y = y * 2;

	-- Return
	return Vector(x, y, 0)
end