Character = class(function(self, Name, SkinCount)
	self.Name = "Characters\\" .. Name
	self.Title = Name .. "_name";
	self.Description = Name .. "_description";
	self.Car = MonsterTruckCar01;
	self.Skin = 6
	
	if SkinCount ~= nil then
		self.SkinCount = SkinCount
	else
		self.SkinCount = 1
	end
	
	self.PlayCount = 0
end)

function Character:Read(File)
	local CharacterCount = File:ReadInt()
	for i = 1, CharacterCount do
		Characters[i].PlayCount = File:ReadInt()
	end
end

function Character:Write(File)
	File:WriteInt(#Characters);
	for i = 1, #Characters do
		File:WriteInt(Characters[i].PlayCount)
	end
end

Player01 = Character("Player01", 6)
Player02 = Character("Player02", 6)
--Player03 = Character("Player03", 6)
Player04 = Character("Player04", 6)
--Player05 = Character("Player05", 6)
Player06 = Character("Player06", 6)
--Player07 = Character("Player07", 6)
--Player08 = Character("Player08", 6)
Player09 = Character("Player09", 6)
--mexicaan--Player10 = Character("Player10", 6)
--kind--Player11 = Character("Player11", 6)


Characters = {Player01, Player02, Player04, Player06, Player09};

SelectedCharacter = Characters[1]