Client = class(function(self)
	self.Client = CreateClient()
	self.Connections = {}

	self.FunctionTable = {}
end)

function Client:SetFunction(Name, Function)
	self.FunctionTable[self.Client:GetFunctionID(Name)] = Function
end

function Client:Connect()
	--self.Client:Connect("192.168.1.123", 1236,
	self.Client:Connect("www.team6-games.com", 80,
		function(...)
			self:Connected(...)
		end,

		function(...)
			self:NotConnected(...)
		end,

		function(...)
			self:Disconnected(...)
		end,

		function(...)
			self:Receive(...)
		end)
end


function Client:Disconnect()
	self.Client:Disconnect(
		function(...)
			self:Disconnected(...)
		end)
	self.Connected = false
end

function Client:Connected()
	print("Client:Connected")
	self.Connected = true
end

function Client:NotConnected()
	print("Client:NotConnected")
	self.Connected = false
end

function Client:Disconnected()
	print("Client:Disconnected")
	self.Connected = false
end

function Client:Receive(FunctionID, Data)
	local Function = self.FunctionTable[tonumber(FunctionID)];

	if (Function ~= nil) then
		Function(Data)
	end
end

function Client:Send(Function, Data)
	self.Client:Send(Function, Data)
end