DebugLines = {}
DebugText = {}

function DebugLineCallback()
	for i = 1, #DebugLines do
		local Line = DebugLines[i];

		DrawLine(Line[1], Line[2], Line[3])
	end
	
	for i = 1, #DebugText do
		local Text = DebugText[i];

		DrawString(Text[1], Text[2], Text[3])
	end

	DebugLines = {}
	DebugText = {}
end

function DrawLineASync(v0, v1, c)
	SetGameRenderCallback(DebugLineCallback)

	table.insert(DebugLines, {v0, v1, c})
end

function DrawStringASync(Text, Pos, Color)
	SetGameRenderCallback(DebugLineCallback)

	table.insert(DebugText, {Text, Pos, Color})
end