DeathMatch = GameMode("DeathMatch")
function DeathMatch:HUD(...)
	return HUD_DeathMatch(...)
end

DeathMatch.Configuration = {}

--Add TrackScores
local TrackScores = { TrackScore("1"), TrackScore("3"), TrackScore("5") }

DeathMatch.RaceUnlockText = "NEW_RACE_UNLOCKED"

DeathMatch:AddCarClass(MonsterTruckCars);

function DeathMatch:PrepareScript(RaceData)
	ActiveMission = DeathMatchMission(RaceData)
end

function DeathMatch:Won()
	--
end

-- Add chapters
local Chapter1 = DeathMatch:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local NewRace = Chapter1:AddRace(Mission("TowTestHouston"))
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

-- Add chapter 1 races
local NewRace = Chapter1:AddRace(Mission("TestPlane"))
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false
NewRace.Unlock = function()
	-- Doe iets hier
end
NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

function DeathMatch:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	
	local LapCount = 1
	
	if (Career == nil) then
		RaceData.Career = false
	else
		RaceData.Career = Career
	end

	-- De speler
	RaceData.Name = GetPlayername() 
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.LapCount = LapCount
	RaceData.Tuning = "Default"
	RaceData.Character = Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]
	
	-- AI data
	RaceData.AI = {}

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadmap("TowTestHouston")
end