HillClimb = GameMode("HillClimb")

function HillClimb:HUD(...)
	return HUD_HillClimb(...)
end

HillClimb.Configuration = {}

--Add TrackScores
local TrackScores = { TrackScore("1") }

HillClimb.RaceUnlockText = "NEW_RACE_UNLOCKED"

HillClimb:AddCarClass(MonsterTruckCars);

HillClimb.UseAccelerateSlider = true

function HillClimb:PrepareScript(RaceData)
	ActiveMission = HillClimbMission(RaceData)
end

function HillClimb:Won()
	--Steam_SetAchievement("STUNTFINISHED")
end

-- Add chapters
local Chapter1 = HillClimb:AddChapter(Chapter("Race_Chapter1")) 

-- Add chapter 1 races
local PrefMission = nil
if (MONSTERJAM_THEME_SETTING == MONSTERJAM_THEME4) then
	PrefMission = Mission("MJ_THEME4_HILLJUMP")
else
	PrefMission = Mission("MJ_THEME1_HILLJUMP")
end
local NewRace = Chapter1:AddRace(PrefMission)
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false;

NewRace.Unlock = function()
	-- Doe iets hier
end

NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

-- Add chapter 1 races
local NewRace = Chapter1:AddRace(Mission("TestPlane"))
NewRace.TrackScores = deepcopy(TrackScores)
NewRace.Available = false;
NewRace.Unlock = function()
	-- Doe iets hier
end

NewRace.Won = function(self, Place, Score)
	return Place <= 3
end

function HillClimb:StartRace(Race, Car, Character, Career)
	local RaceData = {}
	-- Race data
	RaceData.LapCount = 3
	
	if (Career == nil) then
		Career = false
	end
	RaceData.Career = Career

	-- De speler
	RaceData.Name = GetPlayername() --steam_getname();
	RaceData.Car = Car
	RaceData.Skin = 0
	RaceData.Tuning = "Default"
	RaceData.Character = "Characters\\" .. Character
	RaceData.CharacterSkin = 0
	RaceData.CarType = _G[Car]

	--MessageBox(tostring(RaceData.CarType), tostring(RaceData.CarType), 1)
	
	-- AI data
	RaceData.AI = {}

	-- Dit moet om de mission te maken
	PrepareScript = function()
		self:PrepareScript(RaceData)
	end

	-- Laad
	loadscript(Race)
end