CutsceneBars = nil
HUD = nil

TotalDamage = 0;
LaunchAngle = 0;
var("LaunchAngle", 0)

function CharacterDamage(Value)
	if (HUD ~= nil and HUD.CharacterDamage ~= nil) then
		HUD:CharacterDamage(Value)
	end
	
	--TotalDamage = TotalDamage + (Value / 10000)

	--print(string.format("Damage = %f, Total damage = %.2f", Value, TotalDamage))
end

function GetLaunchAngle()
	local Value = tonumber(getvar("LaunchAngle")) % 180
	
	if (Value > 90) then
		Value = 180 - Value
	end
	
	return Value
end

function UpdateLaunchAngle(ElapsedTime)	
	local LaunchAngle = tonumber(getvar("LaunchAngle"));
	
	LaunchAngle = LaunchAngle + ElapsedTime * 90
	
	var("LaunchAngle", LaunchAngle)
end

function HUD_GetPlayerIndex(SymbolicName)
	local Number = string.gsub(SymbolicName, "Player ", "")
	
	Number = tonumber(Number) - 1	-- is dit nodig?
	
	--Number = Number * 4 -- als test
	
	if (HUD ~= nil) then
		if HUD.TeamsSwitched then
			local LastDigit = Number % 2;
			if (LastDigit == 0) then
				Number = Inc(Number);
			else
				Number = Dec(Number)
			end
		end
	end
	return tonumber(Number)
end


function HUD_GetControllerIndex(SymbolicName)
	return HUD_GetPlayerIndex(SymbolicName)
end

function HUD_GetCharacterIndex(SymbolicName, Index)
	local Number = string.gsub(SymbolicName, "Player ", "")
	
	Number = tonumber(Number) - 1	-- is dit nodig?
	if (ActiveGameMode ~= nil and ActiveGameMode ~= nil and ActiveGameMode.Name == "Stuntman") then
		return Number + (Index * 4)	-- als test
	else
		return Number + (Index * 32)
	end
end

--[[function MonsterTrucksShowModel(FileName, PlayerIndex)
	if (HUD ~= nil and HUD.TeamsSwitched) then
		if (FileName == "Models\MTteamRed.DCM") then
			return "Models\MTteamBlue.DCM"
		elseif (FileName == "Models\MTteamBlue.DCM) then
			return Models\MTteamRed.DCM
		end
	end
	
	return FileName
end]]--

DisconnectedUsers = {}

function HUD_NextGoalText()
	if (CutsceneBars ~= nil) then
		if (CutsceneBars.NextGoalText ~= nil) then
			CutsceneBars:NextGoalText()
		end
	end
end

-- Helpers
function xUD_AddCar(Car, Local)
	if (ActiveMission ~= nil and ActiveMission.AddCar ~= nil) then
		ActiveMission:AddCar(Car)
	end


	--if (HUD ~= nil and HUD.AddCar ~= nil) then
		--HUD:AddCar(Car, Local)
	--end
	
	--Car:Enable()
	--Car:EnableInput()
end

function HUD_CarCrash(Car)
	if (HUD ~= nil) then
		if HUD.Player.Car == Car then
			local CrashSpeed = Car:GetSpeed() * 0.36 * 0.75;
			if HUD.CarMaxCrashSpeed_New == nil then
				HUD.CarMaxCrashSpeed_New = 0
			end
			if CrashSpeed > HUD.CarMaxCrashSpeed_New then
				HUD.CarMaxCrashSpeed_New = CrashSpeed
			end
		end
	
		if (HUD.CarCrash ~= nil) then
			HUD:CarCrash(Car)
		end
	end
	
	if (ActiveMission ~= nil) then
		if (ActiveMission.CarCrash ~= nil) then
			ActiveMission:CarCrash(Car)
		end
	end
end

function HUD_Respawn(Car)
	if (HUD ~= nil and HUD.Respawn ~= nil) then
		HUD:Respawn(Car)
	end
end

function HUD_Checkpoint(Car)
	if (ActiveMission ~= nil and ActiveMission.Checkpoint ~= nil) then
		return ActiveMission:Checkpoint(Car)
	end
end

function HUD_Lap(Car)
	if (ActiveMission ~= nil and ActiveMission.Lap ~= nil) then
		return ActiveMission:Lap(Car)
	end
end

function HUD_StartWrongWay(Car)
	if (ActiveMission ~= nil and ActiveMission.StartWrongWay ~= nil) then
		ActiveMission:StartWrongWay(Car)
	end
end

function HUD_EndWrongWay(Car)
	if (ActiveMission ~= nil and ActiveMission.EndWrongWay ~= nul) then
		ActiveMission:EndWrongWay(Car)
	end
end

function HUD_BonusPickup(Car, Type, Amount)
	if (ActiveMission ~= nil and ActiveMission.BonusPickup ~= nil) then
		ActiveMission:BonusPickup(Car, Type, Amount)
	end
end

function HUD_ShowActiveWeapon(Car, WeaponIndex)
	if (ActiveMission ~= nil and ActiveMission.ShowActiveWeapon ~= nil) then
		ActiveMission:ShowActiveWeapon(Car, WeaponIndex)
	end
end

function HUD_HideActiveWeapon(Car, WeaponIndex)
	if (ActiveMission ~= nil and ActiveMission.HideActiveWeapon ~= nil) then
		ActiveMission:HideActiveWeapon(Car, WeaponIndex)
	end
end

function HUD_GetPlace(Car)
	if (ActiveMission ~= nil and ActiveMission.GetPlace ~= nul) then
		return ActiveMission:GetPlace(Car)
	end
end

function HUD_SendSteamStats(ElapsedTime, Forced)
	if HUD ~= nil then
		if HUD.SteamStatsTimer == nil then
			HUD.SteamStatsTimer = 0
		end
		
		HUD.SteamStatsTimer = HUD.SteamStatsTimer + ElapsedTime
		if HUD.SteamStatsTimer > 3 or Forced  then
			HUD.SteamStatsTimer = 0

			-- car_max_crashspeed
			if HUD.CarMaxCrashSpeed == nil then
				--HUD.CarMaxCrashSpeed = Steam_GetStat('car_max_crashspeed')
			end
			if HUD.CarMaxCrashSpeed_New ~= nil then
				if HUD.CarMaxCrashSpeed_New > HUD.CarMaxCrashSpeed then
					--Steam_SetStat('car_max_crashspeed', HUD.CarMaxCrashSpeed_New)
					HUD.CarMaxCrashSpeed = HUD.CarMaxCrashSpeed_New
				end
			end
			
			-- car_max_speed
			if HUD.CarMaxSpeed == nil then
				--HUD.CarMaxSpeed = Steam_GetStat('car_max_speed')
				HUD.CarMaxSpeed = 0
			end
			if HUD.CarMaxSpeed_New ~= nil then
				if HUD.CarMaxSpeed_New > HUD.CarMaxSpeed then
					--Steam_SetStat('car_max_speed', HUD.CarMaxSpeed_New)
					HUD.CarMaxSpeed = HUD.CarMaxSpeed_New
				end
			end
			
			-- car_max_flytime
			if HUD.CarMaxFlytime == nil then
				--HUD.CarMaxFlytime = Steam_GetStat('car_max_flytime')
			end
			if HUD.CarMaxFlytime_New ~= nil then
				if HUD.CarMaxFlytime_New > HUD.CarMaxFlytime then
					--Steam_SetStat('car_max_flytime', HUD.CarMaxFlytime_New)
					HUD.CarMaxFlytime = HUD.CarMaxFlytime_New
				end
			end
			
			-- car_total_flytime
			if HUD.TotalJumpTime ~= nil then
				if HUD.TotalJumpTime > 0 then
					--Steam_IncStat('car_total_flytime', HUD.TotalJumpTime)
					HUD.TotalJumpTime = 0
				end
			end
			
			-- objects_destroyed
			if HUD.ObjectsDestroyed ~= nil then
				if HUD.ObjectsDestroyed > 0 then
					--Steam_IncStat('objects_destroyed', HUD.ObjectsDestroyed)
					HUD.ObjectsDestroyed = 0
				end
			end
			
			-- total_damage_usd
			if HUD.TotalDamageUSD ~= nil then
				if HUD.TotalDamageUSD > 0 then
					--Steam_IncStat('total_damage_usd', HUD.TotalDamageUSD)
					HUD.TotalDamageUSD = 0
				end
			end
			
			-- cars_hitted
			if HUD.CarsHitted ~= nil then
				if HUD.CarsHitted > 0 then
					--Steam_IncStat('cars_hitted', HUD.CarsHitted)
					HUD.CarsHitted = 0
				end
			end
			
			-- cars_destroyed
			if HUD.CarsDestroyed ~= nil then
				if HUD.CarsDestroyed > 0 then
					--Steam_IncStat('cars_destroyed', HUD.CarsDestroyed)
					HUD.CarsDestroyed = 0
				end
			end
			
			-- char_max_flytime
			if HUD.CharMaxFlytime == nil then
				--HUD.CharMaxFlytime = Steam_GetStat('char_max_flytime')
				HUD.CharMaxFlytime = 0
			end
			if HUD.CharMaxFlytime_New ~= nil then
				if HUD.CharMaxFlytime_New > HUD.CharMaxFlytime then
					--Steam_SetStat('char_max_flytime', HUD.CharMaxFlytime_New)
					HUD.CharMaxFlytime = HUD.CharMaxFlytime_New
				end
			end
			
			-- char_total_flytime
			if HUD.CharTotalFlytime ~= nil then
				if HUD.CharTotalFlytime > 0 then
					--Steam_IncStat('char_total_flytime', HUD.CharTotalFlytime)
					HUD.CharTotalFlytime = 0
				end
			end
			
			-- supermove_executions
			if HUD.SupermoveExecutions ~= nil then
				if HUD.SupermoveExecutions > 0 then
					--Steam_IncStat('supermove_executions', HUD.SupermoveExecutions)
					HUD.SupermoveExecutions = 0
				end
			end
			
			-- car_parts_lost
			if HUD.CarPartsLost ~= nil then
				if HUD.CarPartsLost > 0 then
					--Steam_IncStat('car_parts_lost', HUD.CarPartsLost)
					HUD.CarPartsLost = 0
				end
			end
			
			--Steam_StoreStats()
		end
	end
end

function HUD_UpdateRaceData(Car, CheckCount, CheckDist, TimeOffset)
	if (ActiveMission.UpdateRaceData ~= nil) then
		ActiveMission:UpdateRaceData(Car, CheckCount, CheckDist, TimeOffset)
	end

	--[[ if (HUD ~= nil) then
		if (HUD.UpdateRaceData ~= nil) then
			HUD:UpdateRaceData(Car, CheckCount, CheckDist, TimeOffset)
		end
		
		if HUD.Player.Car == Car then
			local Speed = Car:GetSpeed() * 0.36 * 0.75;
			
			if HUD.CarMaxSpeed_New == nil then
				HUD.CarMaxSpeed_New = 0
			end
			if Speed > HUD.CarMaxSpeed_New then
				HUD.CarMaxSpeed_New = Speed
			end
		end
	end ]]--
end

function HUD_StartJump(Car)
	if (HUD ~= nil) then
		--[[ HUD.JumpTime = 0
	
		if (HUD.StartJump ~= nil) then
			HUD:StartJump(Car)
		end ]]--
	end
end

function HUD_UpdateJump(Car, Value, ElapsedTime)
	if (HUD ~= nil and HUD.Player ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if HUD.TotalJumpTime == nil then
				HUD.TotalJumpTime = 0
			end
			HUD.TotalJumpTime = HUD.TotalJumpTime + ElapsedTime
			
			if HUD.JumpTime  == nil then
				HUD.JumpTime = 0
			end
			HUD.JumpTime = HUD.JumpTime + ElapsedTime
		end
		
		if (HUD.UpdateJump ~= nil) then
			HUD:UpdateJump(Car, Value)
		end ]]--
	end
end

function HUD_SucceedJump(Car)
	if (HUD ~= nil and HUD.Player ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if HUD.CarMaxFlytime_New == nil then
				HUD.CarMaxFlytime_New = 0
			end
			if HUD.JumpTime > HUD.CarMaxFlytime_New then
				HUD.CarMaxFlytime_New = HUD.JumpTime
			end
		end
	
		if (HUD.SucceedJump ~= nil) then
			HUD:SucceedJump(Car)
		end ]]--
	end
end

function HUD_FailJump(Car)
	if (HUD ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if HUD.CarMaxFlytime_New == nil then
				HUD.CarMaxFlytime_New = 0
			end
			if HUD.JumpTime > HUD.CarMaxFlytime_New then
				HUD.CarMaxFlytime_New = HUD.JumpTime
			end
		end
		
		if (HUD.FailJump ~= nil) then
			HUD:FailJump(Car)
		end ]]--
	end
end

function HUD_DestroyObject(Car, Cost)
	if (HUD ~= nil and HUD.Player ~= nil) then
		if HUD.Player.Car == Car then
			if HUD.ObjectsDestroyed == nil then
				HUD.ObjectsDestroyed = 0
			end
			HUD.ObjectsDestroyed = HUD.ObjectsDestroyed + 1
			
			if HUD.TotalDamageUSD == nil then
				HUD.TotalDamageUSD = 0
			end
			HUD.TotalDamageUSD = HUD.TotalDamageUSD + Cost
		end
		
		if (HUD.DestroyObject ~= nil) then
			HUD:DestroyObject(Car)
		end
	end
end

function HUD_SpeedKill(Car, Direct)
	if (HUD ~= nil and HUD.SpeedKill ~= nil) then
		HUD:SpeedKill(Car, Direct ~= 0)
	end
end

function HUD_SpeedKilled(Car)
	if (HUD ~= nil and HUD.SpeedKilled ~= nil) then
		HUD:SpeedKilled(Car)
	end
end

function HUD_SpeedCrashed(Car)
	if (HUD ~= nil and HUD.SpeedCrashed ~= nil) then
		HUD:SpeedCrashed(Car)
	end
end

function HUD_DamageCar(Car, Damage)
	print("^2Damaged a car for " ..Damage)
	if (HUD ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if HUD.CarsHitted == nil then
				HUD.CarsHitted = 0
			end
			
			HUD.CarsHitted = HUD.CarsHitted + 1
		end
	
		if (HUD.DamageCar ~= nil) then
			HUD:DamageCar(Car, Damage)
		end ]]--
	end
	
	if (ActiveMission ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if HUD.CarsHitted == nil then
				HUD.CarsHitted = 0
			end
			
			HUD.CarsHitted = HUD.CarsHitted + 1
		end ]]--
	
		if (ActiveMission.DamageCar ~= nil) then
			ActiveMission:DamageCar(Car, Damage)
		end
	end
end

function HUD_Damaged(Car, Damage, HP)
	local Player = GetPlayer(Car)
	if (Player ~= nil) then
		Player:OnCarDamaged(Damage, HP)
	end
	
	if (HUD ~= nil and HUD.Damaged ~= nil) then
		HUD:Damaged(Car, Damage, HP)
	end
end

function HUD_CarKill(Car)
	if (HUD ~= nil) then
		--if HUD.Player.Car == Car then
			if HUD.CarsDestroyed == nil then
				HUD.CarsDestroyed = 0
			end
			HUD.CarsDestroyed = HUD.CarsDestroyed + 1
		--end
	
		if (HUD.CarKill ~= nil) then
			HUD:CarKill(Car)
		end
	end
end

function HUD_CarDead(Car)	
	if (ActiveMission ~= nil) then
		if (ActiveMission.CarDead ~= nil) then
			ActiveMission:CarDead(Car)
		end
	end
end

function HUD_OffroadUpdate(Car, f1, f2, f3)
	if (HUD ~= nil and HUD.OffroadUpdate ~= nil) then
		HUD:OffroadUpdate(Car, f1, f2, f3)
	end
end

function HUD_StuntScore(Car, f1, f2)
	if (HUD ~= nil and HUD.StuntScore ~= nil) then
		HUD:StuntScore(Car, f1, f2)
	end
end

function HUD_StuntFinished(Car)
	if (HUD ~= nil and HUD.StuntFinished ~= nil) then
		HUD:StuntFinished(Car)
	end
end

function HUD_Eject(Car)
	if (HUD ~= nil and HUD.Eject ~= nil) then
		HUD:Eject(Car)
	end
end

function HUD_StuntHitFloor(Car, Flytime)
	if (HUD ~= nil) then
		if HUD.Player.Car == Car then
			if HUD.CharMaxFlytime_New == nil then
				HUD.CharMaxFlytime_New = 0
			end
			if Flytime > HUD.CharMaxFlytime_New then
				HUD.CharMaxFlytime_New = Flytime
			end
			
			if HUD.CharTotalFlytime == nil then
				HUD.CharTotalFlytime = 0
			end
			HUD.CharTotalFlytime = HUD.CharTotalFlytime + Flytime
		end
	end
end

function ActiveMission_JamFinished()
	if (ActiveMission ~= nil and ActiveMission.JamFinished ~= nil) then
		ActiveMission:JamFinished()
	end
end

function HUD_KillMoveStart(Car)
	if (HUD ~= nil) then
		if HUD.Player.Car == Car then
			if HUD.SupermoveExecutions == nil then
				HUD.SupermoveExecutions = 0
			end
			HUD.SupermoveExecutions = HUD.SupermoveExecutions + 1
		end
	end
end

function HUD_CameraChanged(CamIndex)
	if (HUD ~= nil and HUD.ShowCameraInfo ~= nil) then
		HUD:ShowCameraInfo(CamIndex)
	end
end

function HUD_CarPartLost(Car)
	if (HUD ~= nil) then
		if HUD.Player.Car == Car then
			if HUD.CarPartsLost == nil then
				HUD.CarPartsLost = 0
			end
			HUD.CarPartsLost = HUD.CarPartsLost + 1
		end
	end
end

function HUD_UpdateKillMove(Car, Value)
	if (HUD ~= nil) then
		--[[ if HUD.Player.Car == Car then
			if (Value == 1.0) then
				HUD.Menu:GetChild("Killmove"):SetColor(White)
			else 
				HUD.Menu:GetChild("Killmove"):SetColor(Invisible)
			end
		end ]]--
	end
end

function HUD_UserEnter(Lobby, User)
	if (HUD ~= nil and HUD.LeavingPanel ~= nil) then
		HUD.LeavingPanel:SetColorImmediate(White1000000);
		HUD.LeavingPanel:SetColorClamp(true);
		HUD.LeavingPanel:SetColorFade(1, 10);
		HUD.LeavingPanel:SetColor(Invisible)
		
		HUD.LeavingText:SetText(steam_getusername(User) .. " " .. translate("enter_game"))
	else
		table.insert(DisconnectedUsers, User)
	end
end

function HUD_UserLeave(Lobby, User)
	if (HUD ~= nil and HUD.LeavingPanel ~= nil) then
		HUD.LeavingPanel:SetColorImmediate(White1000000);
		HUD.LeavingPanel:SetColorClamp(true);
		HUD.LeavingPanel:SetColorFade(1, 10);
		HUD.LeavingPanel:SetColor(Invisible)
		
		HUD.LeavingText:SetText(steam_getusername(User) .. " " .. translate("leave_game"))
		
		for i, Player in ipairs(HUD.Players) do
			local CharacterCount = Player.Car:GetCharacterCount()
			
			if (CharacterCount > 1) then	-- kan alleen in stunt mode
				for i = 0, CharacterCount - 1 do
					local Character = Player.Car:GetCharacter(i)
					
					if (Character:GetRemoteID() == User) then
						Player.FinishCount = Player.FinishCount + 1
					end
				end
			else
				if (Player.Car:GetRemoteID() == User) then
					Player.Dead = true;
				end
			end
		end
	else
		table.insert(DisconnectedUsers, User)
	end
end

function Win()
	HUD.Player.Finished = true;
	HUD.Player.Rank = 0;
	HUD.Player.TotalScore = 1000000000000
	HUD.Player.Score = 100000000000000
	
	HUD:Proceed()
end