HUD_E_DebugText = class(HUD_E_Base, function(self, HUD, Panel, Element)
	self.DebugText = self.Item:GetChild("DebugText")
	self.Text1 = self.Item:GetChild("Text1")
	self.Text2 = self.Item:GetChild("Text2")
	self.Text3 = self.Item:GetChild("Text3")
	
	self:Hide(true)
end)

function HUD_E_DebugText:Show(Force)
	if (Force) then
		self.DebugText:SetColorImmediate(Invisible)
		--self.DebugText:SetColor(White)
		self.DebugText:SetColorFade(1,10)
	else
		self.DebugText:SetColor(Invisible)
		self.DebugText:SetColorFade(1,10)
	end
end

function HUD_E_DebugText:ShowDebug(Force)
	self.Super.Show(self, Force)
	
	if (Force) then
		self.DebugText:SetColorImmediate(White)
	else
		self.DebugText:SetColor(White)
		self.DebugText:SetColorFade(1,10)
	end
end

function HUD_E_DebugText:Hide(Force)
	self.Super.Hide(self, Force)

	if (Force) then
		self.DebugText:SetColorImmediate(Invisible)
	else
		self.DebugText:SetColor(Invisible)
		self.DebugText:SetColorFade(1,10)
	end
end

function HUD_E_DebugText:SetText(Text1, Text2, Text3)
	self.Text1:SetText(Text1)
	self.Text2:SetText(Text2)
	self.Text3:SetText(Text3)
end