HUD_TowTest = class(HUD_Base, function(self, Mission, Player)
	-- Score Element
	local LocationData = {200,20,Left,Top,Left,Top}
	self.ScoreElement = HUD_E_ScoreElement(self, self.SafeFrame, "hud_Score", LocationData)
	table.insert(self.HUDElements, self.ScoreElement)
	self.ScoreElement:ShowIcon()
	
	-- Warning popup met timer (of andere waarde)
	-- local LocationData = {-16,16, Right, Top , Right, Top}
	-- self.WarningPopup = HUD_E_WarningPopupTimer(self, self.SafeFrame, "hud_WarningPopupTimer", LocationData)
	-- table.insert(self.HUDElements, self.WarningPopup)
	
	-- Slip indicator
	local LocationData = {0,0,0.5,1,0.5,1}
	self.SlipIndicator = HUD_E_SlipIndicator(self, self.SafeFrame, "hud_SlipIndicator", LocationData)
	table.insert(self.HUDElements, self.SlipIndicator)
	
	-- TutorialText Element
	local LocationData = {0, 0, Center, Center, Center, 0.3}
	self.TutorialText = HUD_E_TutorialText(self, self.SafeFrame, "hud_TutorialText", LocationData)
	table.insert(self.HUDElements, self.TutorialText)
end)

function HUD_TowTest:SetScore(Score)
	if (self.ScoreElement ~= nil) then
		self.ScoreElement:SetScore(Round(Score))
	end
end