-- Android

-- Positions of screen buttons:
-- DCK_SCREENBUTTON_6: top right
-- DCK_SCREENBUTTON_7: top left

-- Menu (DEBUG KEYS, once the menu is done, these are not needed anymore because it will work with the "mouse")
var("Android_MenuKeys[0]_0", "DCK_SCREENBUTTON_6") -- proceed
var("Android_MenuKeys[1]_0", "DCK_SCREENBUTTON_7") -- back?

-- Game
var("Android_ForwardKey_0", "DCK_SCREENBUTTON_0")
var("Android_ReverseKey_0", "DCK_SCREENBUTTON_1")
var("Android_LeftKey_0", "DCK_ANDROID_ACCELEROMETER_LEFT")
var("Android_RightKey_0", "DCK_ANDROID_ACCELEROMETER_RIGHT")

var("Android_BoostKey_0", "DCK_SCREENBUTTON_2")
var("Android_CarJumpKey_0", "DCK_SCREENBUTTON_5")

var("Android_MenuKeys[3]_0", "DCK_SCREENBUTTON_7") -- back?
var("Android_MenuKeys[9]_0", "DCK_SCREENBUTTON_8") -- help menu?

-- Keyboard

-- Menu (not configurable)
var("Android_MenuKeys[0]_1", "DCK_RETURN")
var("Android_MenuKeys[0]_2", "DCK_ENTER")
var("Android_MenuKeys[1]_1", "DCK_ESCAPE")
var("Android_MenuKeys[3]_1", "DCK_ESCAPE")
var("Android_MenuKeys[5]_1", "DCK_LEFT")
var("Android_MenuKeys[6]_1", "DCK_DOWN")
var("Android_MenuKeys[7]_1", "DCK_UP")
var("Android_MenuKeys[8]_1", "DCK_RIGHT")
var("Android_MenuKeys[9]_1", "DCK_TAB")

-- Game (configurable)
var("Android_CharacterKeys[0]_1", "DCK_LEFT")
var("Android_CharacterKeys[1]_1", "DCK_RIGHT")
var("Android_CharacterKeys[2]_1", "DCK_UP")
var("Android_CharacterKeys[3]_1", "DCK_DOWN")

var("Android_HandbrakeKey_1", "DCK_SPACE")
var("Android_HandbrakeKey_2", "DCK_LALT")		--Hidden?
var("Android_BoostKey_1", "DCK_LCONTROL")
var("Android_BoostKey_2", "DCK_RCONTROL")		--Hidden?
var("Android_CarUniqueKey_1", "DCK_LSHIFT")
var("Android_RespawnKey_1", "DCK_R")
var("Android_ToggleLightsKey_1", "DCK_L")
var("Android_HornKey_1", "DCK_H")
var("Android_LookBackKey_1", "DCK_B")
var("Android_ChangeCameraKey_1", "DCK_C")
var("Android_CarJumpKey_1", "DCK_LSHIFT")

var("Android_PrevTrackKey_1", "DCK_LBRACKET")
var("Android_PrevTrackKey_2", "DCK_PREVTRACK")	--Hidden
var("Android_NextTrackKey_1", "DCK_RBRACKET")
var("Android_NextTrackKey_2", "DCK_NEXTTRACK")	--Hidden