-- Keyboard

-- Menu (not configurable)
var("Keyboard_MenuKeys[0]_0", "DCK_RETURN")
var("Keyboard_MenuKeys[0]_1", "DCK_ENTER")
var("Keyboard_MenuKeys[1]_0", "DCK_ESCAPE")
var("Keyboard_MenuKeys[3]_0", "DCK_ESCAPE")
var("Keyboard_MenuKeys[5]_0", "DCK_LEFT")
var("Keyboard_MenuKeys[6]_0", "DCK_DOWN")
var("Keyboard_MenuKeys[7]_0", "DCK_UP")
var("Keyboard_MenuKeys[8]_0", "DCK_RIGHT")
var("Keyboard_MenuKeys[9]_0", "DCK_TAB")

-- Game (configurable)
var("Keyboard_ForwardKey_0", "DCK_UP")
var("Keyboard_ReverseKey_0", "DCK_DOWN")
var("Keyboard_LeftKey_0", "DCK_LEFT")
var("Keyboard_RightKey_0", "DCK_RIGHT")

var("Keyboard_CharacterKeys[0]_0", "DCK_LEFT")
var("Keyboard_CharacterKeys[1]_0", "DCK_RIGHT")
var("Keyboard_CharacterKeys[2]_0", "DCK_UP")
var("Keyboard_CharacterKeys[3]_0", "DCK_DOWN")

var("Keyboard_HandbrakeKey_0", "DCK_SPACE")
var("Keyboard_HandbrakeKey_1", "DCK_LALT")		--Hidden?
var("Keyboard_BoostKey_0", "DCK_LCONTROL")
var("Keyboard_BoostKey_1", "DCK_RCONTROL")		--Hidden?
var("Keyboard_CarUniqueKey_0", "DCK_F")
var("Keyboard_RespawnKey_0", "DCK_R") 
var("Keyboard_ToggleLightsKey_0", "DCK_L")
var("Keyboard_HornKey_0", "DCK_H")
var("Keyboard_LookBackKey_0", "DCK_B")
var("Keyboard_ChangeCameraKey_0", "DCK_C")
var("Keyboard_CarJumpKey_0", "DCK_F")

var("Keyboard_PrevTrackKey_0", "DCK_LBRACKET")
var("Keyboard_PrevTrackKey_1", "DCK_PREVTRACK")	--Hidden
var("Keyboard_NextTrackKey_0", "DCK_RBRACKET")
var("Keyboard_NextTrackKey_1", "DCK_NEXTTRACK")	--Hidden
var("Keyboard_RamKeyLeft_0", "DCK_F")
var("Keyboard_RamKeyRight_0", "DCK_G")

var("Keyboard_CarWeaponKey_1", "DCK_LSHIFT")

-- XBOX0 keys

-- Menu (not configurable)
var("Keyboard_MenuKeys[0]_2", "DCK_XBOX0_A")
var("Keyboard_MenuKeys[1]_3", "DCK_XBOX0_B")
var("Keyboard_MenuKeys[3]_2", "DCK_XBOX0_START")
var("Keyboard_MenuKeys[5]_2", "DCK_XBOX0_LTHUMB_LEFT")
var("Keyboard_MenuKeys[5]_3", "DCK_XBOX0_DPAD_LEFT")
var("Keyboard_MenuKeys[6]_2", "DCK_XBOX0_LTHUMB_DOWN")
var("Keyboard_MenuKeys[6]_3", "DCK_XBOX0_DPAD_DOWN")
var("Keyboard_MenuKeys[7]_2", "DCK_XBOX0_LTHUMB_UP")
var("Keyboard_MenuKeys[7]_3", "DCK_XBOX0_DPAD_UP")
var("Keyboard_MenuKeys[8]_2", "DCK_XBOX0_LTHUMB_RIGHT")
var("Keyboard_MenuKeys[8]_3", "DCK_XBOX0_DPAD_RIGHT")

--[[-- Game (not configurable for XBOX0)
var("Keyboard_ForwardKey_2", "DCK_XBOX0_RIGHTTRIGGER")
var("Keyboard_ReverseKey_2", "DCK_XBOX0_LEFTTRIGGER")
var("Keyboard_LeftKey_2", "DCK_XBOX0_LTHUMB_LEFT")
var("Keyboard_RightKey_2", "DCK_XBOX0_LTHUMB_RIGHT")

var("Keyboard_CharacterKeys[0]_2", "DCK_XBOX0_LTHUMB_LEFT")
var("Keyboard_CharacterKeys[1]_2", "DCK_XBOX0_LTHUMB_RIGHT")
var("Keyboard_CharacterKeys[2]_2", "DCK_XBOX0_LTHUMB_UP")
var("Keyboard_CharacterKeys[3]_2", "DCK_XBOX0_LTHUMB_DOWN")

var("Keyboard_HandbrakeKey_2", "DCK_XBOX0_B")
var("Keyboard_HandbrakeKey_3", "DCK_XBOX0_X")
var("Keyboard_BoostKey_2", "DCK_XBOX0_A")
var("Keyboard_CarUniqueKey_2", "DCK_XBOX0_LEFT_SHOULDER")
var("Keyboard_RespawnKey_2", "DCK_XBOX0_BACK")
var("Keyboard_ToggleLightsKey_2", "DCK_XBOX0_RIGHT_SHOULDER")
var("Keyboard_HornKey_2", "DCK_XBOX0_RIGHT_THUMB")
var("Keyboard_LookBackKey_2", "DCK_XBOX0_DPAD_DOWN")
var("Keyboard_ChangeCameraKey_2", "DCK_XBOX0_DPAD_UP")
var("Keyboard_CarJumpKey_2", "DCK_XBOX0_Y")]]--

var("Keyboard_PrevTrackKey_2", "DCK_XBOX0_DPAD_LEFT")
var("Keyboard_NextTrackKey_2", "DCK_XBOX0_DPAD_RIGHT")

-- Game (not configurable for XBOX0)
var("Keyboard_ForwardKey_2", "DCK_XBOX0_RIGHTTRIGGER")
var("Keyboard_ForwardKey_1", "DCK_XBOX0_A")
var("Keyboard_ReverseKey_2", "DCK_XBOX0_LEFTTRIGGER") 
var("Keyboard_LeftKey_2", "DCK_XBOX0_LTHUMB_LEFT")
var("Keyboard_RightKey_2", "DCK_XBOX0_LTHUMB_RIGHT")

var("Keyboard_CharacterKeys[0]_2", "DCK_XBOX0_LTHUMB_LEFT")
var("Keyboard_CharacterKeys[1]_2", "DCK_XBOX0_LTHUMB_RIGHT")
var("Keyboard_CharacterKeys[2]_2", "DCK_XBOX0_LTHUMB_UP")
var("Keyboard_CharacterKeys[3]_2", "DCK_XBOX0_LTHUMB_DOWN")

var("Keyboard_HandbrakeKey_2", "DCK_XBOX0_LEFTTRIGGER")
var("Keyboard_HandbrakeKey_3", "DCK_XBOX0_LEFTTRIGGER")
var("Keyboard_BoostKey_2", "DCK_XBOX0_X")
var("Keyboard_CarUniqueKey_2", "")
var("Keyboard_RespawnKey_2", "DCK_XBOX0_BACK")
var("Keyboard_ToggleLightsKey_2", "")
var("Keyboard_HornKey_2", "")
var("Keyboard_LookBackKey_2", "DCK_XBOX0_RTHUMB_DOWN")
var("Keyboard_ChangeCameraKey_2", "DCK_XBOX0_RIGHT_THUMB")
var("Keyboard_CarJumpKey_2", "DCK_XBOX0_Y")

var("Keyboard_PrevTrackKey_2", "DCK_XBOX0_DPAD_LEFT")
var("Keyboard_NextTrackKey_2", "DCK_XBOX0_DPAD_RIGHT")

var("Keyboard_RamKeyLeft_0", "DCK_XBOX0_LEFT_SHOULDER")
var("Keyboard_RamKeyRight_0", "DCK_XBOX0_RIGHT_SHOULDER")

var("Keyboard_CarWeaponKey_0", "DCK_XBOX0_B")
var("Keyboard_CarUniqueKey_0", "DCK_XBOX0_Y")

var("Keyboard_CarUniqueKey_1", "DCK_F")