-- Eerst alle utils
dofiles("Lua\\Utils\\*.lua")

-- Eerst alle utils
dofiles("Lua\\Engine\\*.lua")

-- Input functions
dofile('lua\\InputDevices\\Input.lua')

-- Video functions
dofile('lua\\Video.lua')

-- Live Data en functions
dofile("Lua\\LiveData.lua")

-- Daarna de highscores
dofiles("Lua\\Highscores\\*.lua")

dofile("Lua\\HighscoresUser.lua")

-- Daarna het menu
dofile('lua\\Menu.lua')
dofile('lua\\Huds\\HUD_Base.lua')

dofile('lua\\MonsterTruckCar.lua')

UnlockPopups = {}

dofile('lua\\CoinManager.lua')

-- Dan de game elementen
dofile('lua\\ShopUpgradeItem.lua')
dofile('lua\\PowerUpItem.lua')
dofile('lua\\DailyMissions.lua')
dofile('lua\\Progress.lua')
dofile('lua\\ScreenMessage.lua')
dofile('lua\\Names.lua')
dofile('lua\\Cars.lua')
dofile('lua\\Characters.lua')
dofile('lua\\GameModes.lua')
dofile('lua\\AIPlayers.lua')
dofile('lua\\AgentAI_RaceDriver.lua')
dofile('lua\\AgentAI_SteeringDriver.lua')
dofile('lua\\PowerManager.lua')
dofile('lua\\TowCarObject.lua')
dofile('lua\\Chain.lua')
dofile('lua\\Saw.lua')
dofile('lua\\DeathObject.lua')
dofile('lua\\PhotoshootCamera.lua')
dofile('lua\\RotatingBeam.lua')
dofile("Lua\\Stunting\\StuntManager.lua")
dofile("Lua\\Suspension\\SuspensionManager.lua")
dofile("Lua\\Upgrading\\Upgrader.lua")
dofile("Lua\\Player.lua")
dofile("Lua\\DestroyableObject.lua")
dofile("Lua\\PickUpManager.lua")
dofile("Lua\\SpecialOffer.lua")

--dofiles("Lua\\Missions\\*.lua")
dofile("Lua\\Missions\\BaseMission.lua")
dofiles("Lua\\Weapons\\*.lua")

-- Laad career mode
dofile("Lua\\CareerRaces.lua")

-- Vervolgens steam
dofile('lua\\Steam.lua')

-- Ten slotte de hud
dofile('lua\\Hud.lua')

--Facebook
FBManager = FacebookManager()

ScoresUser = HighscoresUser()

Kiip = Kiip()

-- Lees de settings file in
ReadGameSettings()

-- Forceer op leeg
UnlockPopups = {}

-- En dan wat standaardstuff
function gb()
	collectgarbage('collect')
	return collectgarbage('count')
end

AlreadyRun = tonumber(getvar("AlreadyRun")) == 1
if (not AlreadyRun) then
	DefaultVideoOptions()
	
	--[[ FastPlatforms = {}
	table.insert(FastPlatforms, "iPhone4,1")	-- iPhone 4S
	table.insert(FastPlatforms, "iPhone5,1")	-- iPhone 5 GSM
	table.insert(FastPlatforms, "iPhone5,2")	-- iPhone 5 GSM+CDMA
	table.insert(FastPlatforms, "iPhone5,3")	-- iPhone 5c GSM
	table.insert(FastPlatforms, "iPhone5,4")	-- iPhone 5c Global
	table.insert(FastPlatforms, "iPhone6,1")	-- iPhone 5s GSM
	table.insert(FastPlatforms, "iPhone6,2")	-- iPhone 5s Global
	table.insert(FastPlatforms, "iPad3,4")		-- iPad 4 WiFi
	table.insert(FastPlatforms, "iPad3,5")		-- iPad 4 GSM
	table.insert(FastPlatforms, "iPad3,6")		-- iPad 4 GSM+CDMA
	table.insert(FastPlatforms, "iPad4,1")		-- iPad Air WiFi
	table.insert(FastPlatforms, "iPad4,2")		-- iPad Air Cellular
	table.insert(FastPlatforms, "iPod5,1")		-- iPod touch 5G
	table.insert(FastPlatforms, "i386")			-- Simulator
	table.insert(FastPlatforms, "x86_64")		-- Simulator ]]
	
	SlowPlatforms = {}
	table.insert(SlowPlatforms, "iPhone1,1")	-- iPhone 1G
	table.insert(SlowPlatforms, "iPhone1,2")	-- iPhone 3G
	table.insert(SlowPlatforms, "iPhone2,1")	-- iPhone 3GS
	table.insert(SlowPlatforms, "iPhone3,1")	-- iPhone 4
	table.insert(SlowPlatforms, "iPhone3,2")	-- iPhone 4 CDMA
	table.insert(SlowPlatforms, "iPhone3,3")	-- Verizon iPhone 4
	table.insert(SlowPlatforms, "iPod1,1")		-- iPod touch 1G
	table.insert(SlowPlatforms, "iPod2,1")		-- iPod touch 2G
	table.insert(SlowPlatforms, "iPod3,1")		-- iPod touch 3G
	table.insert(SlowPlatforms, "iPod4,1")		-- iPod touch 4G
	table.insert(SlowPlatforms, "iPad1,1")		-- iPad 1G 
	table.insert(SlowPlatforms, "iPad2,1")		-- iPad 2 WiFi
	table.insert(SlowPlatforms, "iPad2,2")		-- iPad 2 GSM
	table.insert(SlowPlatforms, "iPad2,3")		-- iPad 2 CDMA
	table.insert(SlowPlatforms, "iPad2,4")		-- iPad 2 CDMAS
	table.insert(SlowPlatforms, "iPad2,5")		-- iPad Mini WiFi
	table.insert(SlowPlatforms, "iPad2,6")		-- iPad Mini GSM
	table.insert(SlowPlatforms, "iPad2,7")		-- iPad Mini GSM+CDMA
	table.insert(SlowPlatforms, "iPad3,1")		-- iPad 3 WiFi
	table.insert(SlowPlatforms, "iPad3,2")		-- iPad 3 CDMA
	table.insert(SlowPlatforms, "iPad3,3")		-- iPad 3 GSM
	table.insert(SlowPlatforms, "iPad4,4")		-- iPad Mini WiFi
	table.insert(SlowPlatforms, "iPad4,5")		-- iPad Mini Cellular
	
	local IOSPlatform = GetIOSDevice()
	print("IOSDeviceID: " .. IOSPlatform)
	if (TableContains(SlowPlatforms, IOSPlatform)) then
		--print("Slow platform, disabling shadows")
		--var("Shadows", 0)
	else
		--print("Fast platform, enabling shadows")
		--var("Shadows", 1)
	end
	
	var("Shadows", 0)
end

var("AlreadyRun", 1)

configsave()
