-- text item
MenuElements.LabelCoin = class(function(self, ItemList, Template, Name, Valuta, Price, Texture, Name2)
	self.Item = MenuItem(Template)
	self.Panel = ItemList.Panel
	self.Enabled = true

	--self.Item = self.Panel:AddItem(Template)
	self.Item:SetColorFade(1, 8)
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItem2 = self.Item:GetChild("Name2")
	self.NameItem2_Flash = self.Item:GetChild("Name2_Flash")
	
	self.CoinsPrice = self.Item:GetChild("CoinsPrice")
	self.ImagePanel = self.Item:GetChild("Image")
	self.ImageBig = self.Item:GetChild("Image_Big")
	self.Root = self.Item:GetChild("Background")
	self.FreeCoinText = self.Item:GetChild("free_coins_text")
	
	self.DiscountItem = self.Item:GetChild("Discount")

	self.Texture = Texture
	
	self.Glow = Glow
	self.Price = Price
	
	-- Init
	self.Item:SetColorImmediate(Halfblack)
	
	self.NameItem:SetText(Translate(Name))
	self.NameItem:SetColorFade(1, 10)
	self.NameItem:SetColorImmediate(White)
	
	self.NameItem2:SetText(Translate(Name2))
	self.NameItem2:SetColorFade(1, 10)
	self.NameItem2:SetColorImmediate(White)
	
	self.NameItem2_Flash:SetText(Translate(Name2))
	self.NameItem2_Flash:SetColorFade(1, 3)
	self.NameItem2_Flash:SetColorImmediate(White)
	
	
	if (Price ~= 0) then
		--local PriceStr = string.format("$ %.2f", Price)
		--local PriceStr = string.format(Translate("valuta_dollar"), Price)
		--local PriceStr = string.format(Translate("valuta_dollar"), Price)
		--local PriceStr = ("empty")
		--self.CoinsPrice:SetText(Translate(PriceStr))
		
		self.CoinsPrice:SetText(tostring(Valuta) .. " " .. tostring(Price))
		--self.CoinsPrice:SetText(Valuta)
	else
		self.CoinsPrice:SetText("")
	end
	
	if (self.Texture ~= nil) then
		self.ImagePanel:SetImage(self.Texture)
	end
	
	-- if (BigTexture == true) then
		-- self.ImageBig:SetColor(White)
		-- self.ImagePanel:SetColor(Invisible)
		-- self.FreeCoinText:SetColor(White)
		-- self.Root:SetSize(600,116)
	-- end

	-- Functions
	self.Item:SetActivateFunc(function()
		if (self.Enabled) then
			ItemList:SetSelection(self)

			if (self.OnActivate ~= nil) then
				self.OnActivate()
			end
		end
	end)

	self.Item:SetDeactivateFunc(function()
		if (self.Enabled) then
			ItemList:UnsetSelection(self)

			if (self.OnDeactivate ~= nil) then
				self.OnDeactivate()
			end
		end
	end)

	self.Item:SetClickedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				ItemList:SetSelection(self)

				if (self.OnClicked ~= nil) then
					self.OnClicked()
				end
			end
		end
	end)

	self.Item:SetReleasedFunc(function()
		if (ActiveForeground.MouseOver <= 0 and not ItemList:IsSliding()) then
			if (self.Enabled) then
				ItemList:SetSelection(self)

				if (self.OnReleased ~= nil) then
					self.OnReleased()
				end
			end
		end
	end)

	self.Item:SetScrollFunc(function(Value)
		if (self.Enabled) then
			if (self.OnScroll ~= nil) then
				self.OnScroll(Value)
			end
		end
	end)
end)

function MenuElements.LabelCoin:SetText(Text)
	self.NameItem:SetText(translate(Text))
end

function MenuElements.LabelCoin:SetDiscountText(Text)
	self.DiscountItem:SetColor(White)
	self.DiscountItem:SetText(translate(Text))
end

function MenuElements.LabelCoin:Activate() -- standaard multilist selectie kleuren 
	self.Item:SetColorImmediate(White)
	self.Item:SetColor(color(0, 0, 0, 0.5))
	self.NameItem:SetColor(White)
end

function MenuElements.LabelCoin:Deactivate()
	self.Item:SetColor(Halfblack)
	
	if self.Glow then
		self:PulseGlowItem()
	end
	--self.NameItem2:SetColorImmediate(Invisible)
end

function MenuElements.LabelCoin:DelItem(Index)
	--self.Panel:DelItem(Index)
end