MenuElements.Stunt = class(function(self, HUD, ItemList, Template, StuntName)
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	
	self.NameItem = self.Item:GetChild("Name")
	self.StarPanel = self.Item:GetChild("StarPanel")
	self:SetText(StuntName)
	
	local PosX, PosY = self.NameItem:GetPos()
	self.Stars = MenuElements.Stars(nil, "hud\\elements\\hud_Star.dcMenu", HUD, self.StarPanel, 3, PosX + self.NameItem:GetWidth() + 10, 0)
end)

function MenuElements.Stunt:SetText(Text)
	self.NameItem:SetText(Text)
end

function MenuElements.Stunt:SetScore(Score)
	self.Stars:ShowStars(Score)
end