MenuElements.Requirement = class(function(self, Panel, Template, Name)
	self.Item = MenuItem(Template)
	self.Panel = Panel
	self.Name = Name
	self.Enabled = true
	self.Passed = false

	--self.Item = self.Panel:AddItem(Template)

	-- Init
	self.NameItem = self.Item:GetChild("Name")
	--self.NameItemFlash = self.Item:GetChild("NameFlash")
	
	self.Color = Red
	self.Color_Passed = Green --White
	
	self:UpdateText()
	self:UpdateTextColor()
end)

function MenuElements.Requirement:DelItem(Index)
	--self.Panel:DelItem(self.Item)
end

function MenuElements.Requirement:Activate()
	--
end

function MenuElements.Requirement:Deactivate()
	--
end

function MenuElements.Requirement:Enable()
	if (not self.Enabled) then
		self.Enabled = true
		--
	end
end

function MenuElements.Requirement:Disable()
	if (self.Enabled) then
		self.Enabled = false
		--
	end
end

function MenuElements.Requirement:SetText(Text)
	self.NameItem:SetText(Text)
	--self.NameItemFlash:SetText(Text)
end

function  MenuElements.Requirement:UpdateText(Text)
	if (Text ~= nil) then
		self.Name = Text
	end
	
	self:SetText(translate(self.Name))
end

function  MenuElements.Requirement:UpdateTextColor(Color)
	if (Color ~= nil) then
		self.Color = Color
	end
	
	if (self.Passed) then
		self.NameItem:SetColor(self.Color_Passed)
	else
		self.NameItem:SetColor(self.Color)
	end
end

function MenuElements.Requirement:PassReq()
	if (not self.Passed) then
		self.Passed = true
		
		self:UpdateText()
		self:UpdateTextColor()
	end
end

function MenuElements.Requirement:UnpassReq()
	if (self.Passed) then
		self.Passed = false
		
		self:UpdateText()
		self:UpdateTextColor()
	end
end
-- =========
