-- text item
MenuElements.ResultPlayer = class(function(self, ItemList, Template, Name1, Name2, VersusText, Color1, Color2)
	self.Item = MenuItem(Template)
	self.Item:SetColorFade(1, 8)

	self.LeftNameItem = self.Item:GetChild("Name_Left")
	self.RightNameItem = self.Item:GetChild("Name_Right")

	self.LeftPlayerColor = self.Item:GetChild("LeftPlayerColor")
	self.RightPlayerColor = self.Item:GetChild("RightPlayerColor")
	self.VersusText = self.Item:GetChild("VersusText")
	
	-- Init

	self.LeftNameItem:SetText(Name1)
	
	if Name2 ~= nil then
		self.RightNameItem:SetText(Name2)
	end	
	
	if VersusText ~= nil then
		self.VersusText:SetText(translate(VersusText))
	end
	
	if Color1 ~= nil then
		self.LeftPlayerColor:SetColorData(Color1, 0, None, false)
	end
	
	if Color2 ~= nil then
		self.RightPlayerColor:SetColorData(Color2, 0, None, false)
	end

	local Name1_Size = self.LeftNameItem:GetWidth()
	local Name2_Size = self.RightNameItem:GetWidth()
	
	if Name1_Size < 256 then
		local Name1_Size = 256
		print("true")
	end
		
	if Name2_Size < 256 then
		local Name2_Size = 256
		print("true2")
	end
	
	print("Name1_Size" .. Name1_Size)
	print("Name2_Size" .. Name2_Size)
	
	local TotalSize = 0
	
	if Name1_Size > Name2_Size then
		TotalSize = (Name1_Size * 2) + 96
	else
		TotalSize = (Name2_Size * 2) + 96
	end
	
	print("TotalSize =" .. TotalSize)

	self.Item:SetWidth(TotalSize)
	self.LeftPlayerColor:SetWidth(Name1_Size)
	self.RightPlayerColor:SetWidth(Name2_Size)
end)

function MenuElements.ResultPlayer:SetText(Text)
	--
end

function MenuElements.ResultPlayer:Activate() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultPlayer:Clicked() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultPlayer:Deactivate()
	--
end

function MenuElements.ResultPlayer:DelItem(Index)
	--
end

function MenuElements.ResultPlayer:Enable()
	--
end

function MenuElements.ResultPlayer:Disable()
	--
end