-- text item
MenuElements.ResultPlayerScores = class(function(self, ItemList, Template, Name, VersusText, LeftTotal, LeftScore, RightTotal, RightScore)
	self.Item = MenuItem(Template)
	self.Item:SetColorFade(1, 8)

	self.LeftNameItem = self.Item:GetChild("Name_Left")
	self.RightNameItem = self.Item:GetChild("Name_Right")

	self.LeftPlayerColor = self.Item:GetChild("LeftPlayerColor")
	self.RightPlayerColor = self.Item:GetChild("RightPlayerColor")
	self.VersusText = self.Item:GetChild("VersusText")
	
	self.Value_Left = self.Item:GetChild("Value_Left")
	self.Value_Right = self.Item:GetChild("Value_Right")
	
	self.Score_Left = self.Item:GetChild("Score_Left")
	self.Score_Right = self.Item:GetChild("Score_Right")
	
	-- Init

	self.LeftNameItem:SetText(string.upper(translate(Name)))
	self.VersusText:SetText(string.upper(translate(VersusText)))
	
	self.Results = {}
	self.Results["LEFT"] = {LeftTotal, LeftScore}
	self.Results["RIGHT"] = {RightTotal, RightScore}
	
	self.Value_Left:SetText(self.Results["LEFT"][1])
	self.Score_Left:SetText(self.Results["LEFT"][2])
	
	self.Value_Right:SetText(self.Results["RIGHT"][1])
	self.Score_Right:SetText(self.Results["RIGHT"][2])
	
	--self:SetRandomScores()
end)

function MenuElements.ResultPlayerScores:SetRandomScores() -- testing only

	-- [value x] [multiplier =] [score]

	self.Value_Left = self.Item:GetChild("Value_Left")
	self.Score_Left = self.Item:GetChild("Score_Left")
	
	local RandomValue = math.random (0, 100)
	local RandomMultiplier = (math.random (1, 3)) * 10
	
	if RandomMultiplier == 30 then
		RandomMultiplier = RandomMultiplier + 10
	end

	local Score = RandomValue * RandomMultiplier
	
	--self.Value_Left:SetText(RandomValue .. " x " .. RandomMultiplier .. " = " .. Score) -- score 1
	self.Value_Left:SetText(RandomValue)
	self.Score_Left:SetText(Score)

	-- score player 2 /cpu
	
	self.Value_Right = self.Item:GetChild("Value_Right")
	self.Score_Right = self.Item:GetChild("Score_Right")

	local RandomValue = math.random (0, 100)
	local RandomMultiplier = (math.random (1, 3)) * 10
	
	if RandomMultiplier == 30 then
		RandomMultiplier = RandomMultiplier + 10
	end

	local Score = RandomValue * RandomMultiplier

	self.Value_Right:SetText(RandomValue)
	self.Score_Right:SetText(Score)
	
	--self.Value_Right:SetText(RandomValue .. " x " .. RandomMultiplier .. " = " .. Score) -- score 2

end

function MenuElements.ResultPlayerScores:SetText(Text)
	--
end

function MenuElements.ResultPlayerScores:Activate() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultPlayerScores:Clicked() -- standaard multilist selectie kleuren 
	--
end

function MenuElements.ResultPlayerScores:Deactivate()
	--
end

function MenuElements.ResultPlayerScores:DelItem(Index)
	--
end

function MenuElements.ResultPlayerScores:Enable()
	--
end

function MenuElements.ResultPlayerScores:Disable()
	--
end