MenuElements.Stars = class(function(self, ItemList, Template, HUD, Panel, Amount, OffsetX, OffsetY, Alignment)
	
	self.Item = MenuItem(Template)
	self.ItemList = ItemList
	self.Amount = Amount
	self.StarPanel = Panel--self.Item:GetChild("StarPanel")
	self.StarList = NewItemList(self, nil, nil)
	self.Alignment = Alignment
	if(self.Alignment == nil) then
		self.Alignment = ALIGN_WE
	end
	
	for i = 1, Amount do
		self.StarList:AddItem(self.StarPanel, MenuElements.Label(self.StuntList, "hud\\elements\\hud_Star.dcMenu"))
		self.StarList.Items[i].Item:GetChild("Star"):SetColor(Invisible)
	end
	
	self.StarList:Format(self.Alignment, OffsetX, OffsetY, 0, 0, Left, Top, Left, Top, 0)
end)

function MenuElements.Stars:ShowStars(AmountShown)
	for i = 1, self.Amount do
		self.StarList.Items[i].Item:GetChild("Star"):SetColor(Invisible)
		
		if (i <= AmountShown) then
			self.StarList.Items[i].Item:GetChild("Star"):SetColor(White)
		end
	end
end