MenuElements = {}
HUDElements = {}

if (Win32()) then
	ProceedButtons = {"DCK_ENTER", "DCK_RETURN", "DCK_XBOX0_A", "DCK_MOUSE0"}
	BackButtons = {"DCK_ESCAPE", "DCK_XBOX0_B", "DCK_N3DS_A"}
	SelectButtons = {"DCK_ENTER", "DCK_RETURN", "DCK_XBOX0_A"}
	
	ToggleMenuButtons = {"DCK_ESCAPE", "DCK_SCREENBUTTON_1"} 

	LeftButtons = {"DCK_LEFT", "DCK_XBOX0_LTHUMB_LEFT", "DCK_XBOX0_DPAD_LEFT"}
	RightButtons = {"DCK_RIGHT", "DCK_XBOX0_LTHUMB_RIGHT", "DCK_XBOX0_DPAD_RIGHT"}

	UpButtons = {"DCK_UP", "DCK_XBOX0_LTHUMB_UP", "DCK_XBOX0_DPAD_UP"}
	DownButtons = {"DCK_DOWN", "DCK_XBOX0_LTHUMB_DOWN", "DCK_XBOX0_DPAD_DOWN"}
elseif (GetPlatform() == "Wii") then
	ProceedButtons = {"DCK_WII0_2"}
	BackButtons = {"DCK_WII0_1"}
	SelectButtons = {"DCK_WII0_2"}
	
	ToggleMenuButtons = {"DCK_WII0_MINUS"}

	LeftButtons = {"DCK_WII0_UP"}
	RightButtons = {"DCK_WII0_DOWN"}

	UpButtons = {"DCK_WII0_RIGHT"}
	DownButtons = {"DCK_WII0_LEFT"}
elseif (n3ds()) then
	ProceedButtons = {"DCK_N3DS_B", "DCK_MOUSE0"}
	BackButtons = {"DCK_N3DS_A"}
	SelectButtons = {"DCK_N3DS_B"}
	
	ToggleMenuButtons = {"DCK_N3DS_START"}

	LeftButtons = {"DCK_N3DS_LEFT", "DCK_XBOX0_LTHUMB_LEFT", "DCK_XBOX0_DPAD_LEFT"}
	RightButtons = {"DCK_N3DS_RIGHT", "DCK_XBOX0_LTHUMB_RIGHT", "DCK_XBOX0_DPAD_RIGHT"}

	UpButtons = {"DCK_N3DS_UP", "DCK_XBOX0_LTHUMB_UP", "DCK_XBOX0_DPAD_UP"}
	DownButtons = {"DCK_N3DS_DOWN", "DCK_XBOX0_LTHUMB_DOWN", "DCK_XBOX0_DPAD_DOWN"}
else
	ProceedButtons = {"DCK_MOUSE0"}
	BackButtons = {}
	SelectButtons = {}
	
	ToggleMenuButtons = {"DCK_SCREENBUTTON_1"}

	LeftButtons = {}
	RightButtons = {}

	UpButtons = {}
	DownButtons = {}
end