ExtrasCredits = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("Credits")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("ExtrasCredits", nil, function()
	
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)

		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		self.CreditsTextPanel = self.Menu:getchild("CreditsTextPanel")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		ActiveForeground:HideInfoText()
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
		
		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		--
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			print("^3ExtraCredits ^7> ^2OptionsMenu")
			
			self.BackButton.OnReleased = nil
			
			-- if (self.PreviousMenu ~= nil) then
				-- self:Goto(self.PreviousMenu)
			-- else
				self:Goto(MainMenu)
			-- end
		end
		
		if (false) then	--FREE MONEY CHEAT!!!
			self.Main:SetDoubleClickedFunc(function()
				GameThread:Spawn(function()
					if (MouseKeyPressed(0)) then
						GameThread:Sleep(5 / 60)
						if (MouseKeyPressed(0)) then
							--VirtualCoins:AddCoinCount(100000)
							--VirtualCoins:AddGoloCoinCount(500)
							VirtualCoins:AddGoloCoinCount(1)
							WriteGameSettings(true)
						end
					end
				end)
			end)
		end
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		--self.Items:SetSelection(self.BackButton)
		self.BackButton:Flash(1, true, true, 0.5)
		
		
		-- KeyListeners
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.PreviousMenu ~= nil) then
					self:Goto(self.PreviousMenu)
				else
					self:Goto(MainMenu)
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end)
end)

function ExtrasCredits:Goto(Target)
	ActiveMenu = Target(ExtrasCredits)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function ExtrasCredits:Active()
	return ActiveMenu == self
end

function ExtrasCredits:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = ExtrasCredits(PreviousMenu)
end

function ExtrasCredits:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	self.CreditsTextPanel:SetColor(White)
	self.CreditsTextPanel:SetPosData(0, 25, Center, Top, Center, Bottom, 1, None, false) -- "reset" on enter
	self.CreditsTextPanel:SetPosData(0, 0, Center, Bottom, Center, Top, 0.03, Linear, true)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function ExtrasCredits:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	self.CreditsTextPanel:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function ExtrasCredits:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function ExtrasCredits:Back()
	self:Goto(MainMenu)
end