Garage_Viewer_ITEMLIST_CATEGORIES = 1
Garage_Viewer_ITEMLIST_CARS = 2

Garage_Viewer_ActiveItemList = Garage_Viewer_ITEMLIST_CATEGORIES

Garage_Viewer_ItemList_Categories_Active = 1
Garage_Viewer_ItemList_Cars_Active = nil
Garage_Viewer_ItemList_Wheels_Active = nil
Garage_Viewer_ItemList_Colors_Active = nil

Garage_Viewer = class(function(self, PreviousMenu, Car)
	self.PreviousMenu = PreviousMenu
	
	--CheckOnlineProgress()
	
	AnalyticsSendScreenName("Garage_Viewer")
	
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenu("Garage_Viewer")

	-- Pak het hoofdpanel
	self.Main = self.Menu:GetChild("Main")
	
	-- SafeFrame pakken en zetten
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	
	--
	self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	ActiveForeground:HideInfoText()
	
	--Show menu
	self.MenuDelItem_Queue = {}
	self:ShowMenu()
	
	self.VehicleNameImage = self.Menu:GetChild("VehicleNameImage")
	
	self.ActiveItemList = nil
	
	-- ========================
	
	self:CreateCarRender()
	if (Car ~= nil) then
		self:ShowCar(Car)
	else
		--ActiveMission.CarManager:ResetCarSelection()
	end
	--self:ShowCategoryButtons()
	
	
	self.CategoryItemsPanel = self.Menu:GetChild("CategoryItems")
	
	-- Panels leegmaken en lijst aanmaken
	self.Items_Categories = NewItemList(self, nil, nil)
	self.Items_Categories.Wrapping = false
	self.Items_Categories.Panel = self.CategoryItemsPanel
	self.Items_Categories.Panel:Clear()
	self.Items_Categories.TotalNormalButtons = 0
	
	-- Add back button
	self.Items_Categories.BackButton = self.Items_Categories:AddItem(self.BottomBarItems, MenuElements.Label(self.Items_Categories, "Elements\\MenuButtonBack.dcMenu", "button_back"))
	--self.Items_Categories.BackButton.Selectable = false
	table.insert(self.MenuDelItem_Queue, self.Items_Categories.BackButton)
	
	--Back button action
	self.Items_Categories.BackButton.OnReleased = function()
		self.Items_Categories.BackButton.OnReleased = nil
		self:Goto(CarSelect)
	end
	
	
	
	-- if (Garage_Viewer_ActiveItemList == Garage_Viewer_ITEMLIST_CATEGORIES) then
		-- --if (PlayerHasCar()) then
			-- ActiveMission.CarManager:ResetCarSelection()
			-- self:ShowCategoryButtons()
		-- --else
			-- --self:ShowCarButtons()
		-- --end
	-- --elseif (Garage_Viewer_ActiveItemList == Garage_Viewer_ITEMLIST_CARS) then
		-- --self:ShowCarButtons()
	-- else
		-- --if (PlayerHasCar()) then
			-- ActiveMission.CarManager:ResetCarSelection()
			-- self:ShowCategoryButtons()
		-- --else
			-- --self:ShowCarButtons()
		-- --end
	-- end
	
	-- GameThread:Spawn(function()
		-- --FirstPlayOffer = false
		-- if (not FirstPlayOffer) then
			-- FirstPlayOffer = true
			-- local FreeCoins = 7000
			-- ShowConfirm_Intro(FreeCoins)
		-- end
	-- end)
	
	GameThread:Spawn(function()
		if (ActiveMission.CarRender ~= nil) then
			ActiveMission.CarRender:Enable()
		end
		--if (ActiveMission.ObjectRender ~= nil) then
			--ActiveMission.ObjectRender:Disable()
		--end
		
		if (ActiveMission.CarRender ~= nil) then
			ActiveMission.CarRender.CamHelper:Update()
		end
		
		if (ActiveMission.CarManager:GetCarSelection() ~= nil) then
			self:SetCarImageName(ActiveMission.CarManager:GetCarSelection())
		end
	end)
end)

function Garage_Viewer:InitKeyListeners()
	ClearKeyListeners()

	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active()) then
			
			self:Goto(CarSelect)
			--[[ if (self.ActiveItemList ~= nil and self.ActiveItemList.BackButton ~= nil) then
				if (self.ActiveItemList.BackButton.OnReleased ~= nil and self.ActiveItemList.BackButton.Enabled) then
					self.ActiveItemList.BackButton:OnReleased()
				end
			end ]]
		else
			DelKeyListeners(Listeners)
		end
	end)

	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.ActiveItemList ~= nil) then
				if (self.ActiveItemList == self.Items_Cars) then
					if (self.Items_Bottom:GetSelection() ~= nil) then
						if (self.Items_Bottom:GetSelection().OnReleased ~= nil) then
							self.Items_Bottom:GetSelection():OnReleased()
						end
					end
				else
					if (self.ActiveItemList:GetSelection() ~= nil) then
						if (self.ActiveItemList:GetSelection().OnReleased ~= nil) then
							self.ActiveItemList:GetSelection():OnReleased()
						end
					end
				end
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(UpButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ActiveItemList:Prev()
				if(self.ActiveItemList == self.Items_Cars) then
					self.ActiveItemList:GetSelection():OnReleased()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(DownButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				self.ActiveItemList:Next()
				if(self.ActiveItemList == self.Items_Cars) then
					self.ActiveItemList:GetSelection():OnReleased()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(LeftButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				if(self.ActiveItemList == self.Items_Cars) then
					self.Items_Bottom:Prev()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(RightButtons, "TimedDown", function(Listeners)
		if (self:Active()) then
			GameThread:Spawn(function()
				if(self.ActiveItemList == self.Items_Cars) then
					self.Items_Bottom:Next()
				end
			end)
		else
			DelKeyListeners(Listeners)
		end
	end)
end

function Garage_Viewer:Goto(Target)
	--if (self.DeliveryClockThread ~= nil) then
		--GameThread:Stop(self.DeliveryClockThread)
		--self.DeliveryClockThread = nil
	--end
	
	ActiveMenu = Target(Garage_Viewer)
	self:HideMenu()
	
	if (self.ActiveItemList ~= nil and self.ActiveItemList.DisableSliding ~= nil) then
		self.ActiveItemList:DisableSliding()
	end
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function Garage_Viewer:Active()
	return ActiveMenu == self
end

function Garage_Viewer:Refresh()
	self:Destroy()

	local PreviousMenu = self.PreviousMenu
	ActiveMenu = Garage_Viewer(PreviousMenu)
end

function Garage_Viewer:Destroy()
	self:DestroyCarRender()
end

function Garage_Viewer:ShowMenu()
	print("self:ShowMenu()")
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
	
	--if(ActiveGameMode:GetSelectedCar() ~= nil and ActiveGameMode:GetSelectedCar().Bought) then
		--ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
	--else
		--ActiveForeground:HideCarName()
	--end
	self:InitKeyListeners()
end

function Garage_Viewer:HideMenu(Force)
	if (Force) then
		self.Main:SetColorImmediate(Invisible)
	else
		self.Main:SetColorFade(1, 4)
		self.Main:SetColor(Invisible)
	end
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		if (Force) then
			MenuItem.Item:SetColorImmediate(Invisible)
		else
			MenuItem.Item:SetColorFade(1, 4)
			MenuItem.Item:SetColor(Invisible)
		end
	end
end

function Garage_Viewer:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
	
	GameThread:Spawn(function()
		self:Destroy()
	end)
end

function Garage_Viewer:Back()
	self:Goto(CarSelect)
end

-- ==========================================
-- Custom functions below here
-- ==========================================

function Garage_Viewer:CreateCarRender()
	print("Garage_Viewer:CreateCarRender")
	self.WorldRenderTexture = self.Menu:GetChild("WorldRenderTexture")
	
	local ContentHeight = ActiveForeground:GetContentHeight() 
	local PanelWidth = SafeFrameWidth -- self.CategoryPanel:GetWidth() 
	local BorderOffset = 4
	
	local TopBarSize = 128 -- ophalen uit foregroundmenu
	local Garage_ViewerrenderYpos = TopBarSize + BorderOffset
	
	--self.WorldRenderTexture:SetPosData(-4 - self.CategoryPanel:GetWidth() , Garage_ViewerrenderYpos, Right, Top, Right, Top, 4, Linear, false)
	--self.WorldRenderTexture:SetPosData(-4, Garage_ViewerrenderYpos, Right, Top, Right, Top, 4, Linear, false)
	--self.WorldRenderTexture:SetSize(PanelWidth - 2 * BorderOffset, ContentHeight - (2 * BorderOffset))
	
	self.WorldRenderTexture:SetColorImmediate(Invisible)
	PhysicsThread:Spawn(function()
		PhysicsThread:Wait(3)
		if (self.WorldRenderTexture ~= nil) then
			self.WorldRenderTexture:SetColorFade(1, 1)
			self.WorldRenderTexture:SetColor(White)
		end
	end)
	
	if (ActiveMission.CarRender ~= nil) then
		ActiveMission.CarRender:SetMenuImage(self.WorldRenderTexture)
	end
	
	self.WorldRenderTexture:SetClickedFunc(function(Item, X, Y)
		GameThread:Spawn(function()
			while (MouseKeyPressed(0)) do
				if (ActiveMission.CarRender ~= nil) then
					if (PrevMousePos == nil) then
						PrevMousePos = MousePos(0)
					end
					
					local DeltaX = MousePos(0).x - PrevMousePos.x
					local DeltaY = MousePos(0).y - PrevMousePos.y
					PrevMousePos = MousePos(0)
					
					ActiveMission.CarRender.RotationSpeed = ActiveMission.CarRender.RotationSpeed + (-DeltaX / 30)
					ActiveMission.CarRender.LiftSpeed = ActiveMission.CarRender.LiftSpeed + (DeltaY / 30)
				end
				GameThread:Wait(1 / 120)
			end
			PrevMousePos = nil
		end)
	end)
end

function Garage_Viewer:DestroyCarRender()
	if (self.WorldRenderTexture ~= nil) then
		ActiveMission.CarRender:SetMenuImage(nil)
		ActiveMission.CarRender.ImageReady = false
		self.WorldRenderTexture:SetClickedFunc(nil)
		self.WorldRenderTexture = nil
	end
end


function Garage_Viewer:ShowCar(Car)
	--GameThread:Spawn(function()
		ActiveMission.CarManager:ShowCar(Car)
	--end)
end

function Garage_Viewer:SetCarImageName(Car)	
	self.VehicleNameImage:SetImage(Car.LogoImage)
end

