InGameMenuSelection = 0

InGameMenu = class(function(self)
	-- gooi menu er op
	self.Menu = PushMenu("InGameMenu")
	AnalyticsSendScreenName("InGameMenu")
	
	-- Pak het hoofdpanel en overige panels
	self.Main = self.Menu:GetChild("Main")
	self.ItemsPanel = self.Main:getchild("Items")
	self.SafeFrame = self.Menu:GetChild("SafeFrame")
	self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
	--self.InfoItems = self.Main:getchild("InfoItems")
	--self.InfoItemsText = self.Menu:getchild("InfoItemsText")
	--self.InfoItemsText_Flash = self.Menu:getchild("InfoItemsText_Flash")
	
	-- Fade in items
	--self.Main:SetColorData(Invisible, 2, None, false)
	--self.Main:SetColorData(White, 2, Sine, false)
	self.Main:SetColorData(Invisible, 1, None, false)
	self:ShowMenu()
	
	--self.InfoItems:SetColorData(Invisible, 1, None, false)
	--self.InfoItems:SetColorData(White, 1, Sine, false)
	
	--self.InfoItemsText_Flash:setcolorimmediate(Invisible)
	--self.InfoItemsText_Flash:setcolorfade(1, 10.0)
	
	-- Panels leegmaken en lijst aanmaken
	local Items = NewItemList(self, UpButtons, DownButtons)
	Items.Panel = self.ItemsPanel
	--Items.Panel:Clear()		--Dit crasht ???

	self.Items = Items
	
	
	local SmallScreen = (ScreenSize == Resolutions.iphone) or (ScreenSize == Resolutions.n3ds)
	self.ButtonTemplate = "Elements\\MenuButtonBig.dcMenu"
	
	-- Items toevoegen
	self.Resume = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_resume", nil, true));
	self.Resume.OnDeactivate = function()
		if (self:Active()) then
			self.Resume:Deactivate()
		end
	end
	
	self.Resume.OnClicked = function()
		if (self:Active()) then
			self.Resume:Activate()
		end
	end
	
	self.Resume.OnReleased = function()
		if (self:Active()) then
			--self.Resume:Deactivate()
			
			var("IntPause", 0)
			--self:ToggleMenu()
			ActiveMission:HideIngameMenu()
			AnalyticsSendScreenName(ActiveGameMode.Name)
		end
	end

	self.Restart = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_restart"));	
	
	if (not FuelEnergy:IsPowerAvailable()) then
		self.Restart:Disable()
		self.Restart:SetText(Translate("button_restartnofuel"))
	else
		self.Restart:Enable()
	end
	
	self.Restart.OnDeactivate = function()
		if (self:Active()) then
			self.Restart:Deactivate()
		end
	end
	
	self.Restart.OnClicked = function()
		if (self:Active()) then
			self.Restart:Activate()
		end
	end
	
	self.Restart.OnReleased = function()
		if (self:Active()) then
			ActiveMenu.Items.EnableInput = false
			
			
			PreviousMenu = self
			ActiveMenu = ConfirmMenu(PreviousMenu)
			
			ActiveMenu:SetTitle(Translate("confirm_restart"))
			ActiveMenu:SetText(Translate("confirm_restart_text"))
			ActiveMenu:SetCharacter(CharacterTextures["Johnny"], translate("character_Johnny"))
			
			if (PreviousMenu.HideMenu ~= nil) then
				PreviousMenu:HideMenu()
			end
			
			ActiveMenu.NoButton.OnReleased = function()
				ActiveMenu.NoButton.OnReleased = nil
				GameThread:Spawn(function()
					ActiveMenu.Main:SetColorImmediate(Invisible)
					PopMenu("ConfirmMenu")
					
					ActiveMenu = InGameMenu()
					if (ActiveMenu.ShowMenu ~= nil) then
						ActiveMenu:ShowMenu()
					end
					ActiveMenu.Items.EnableInput = true
					
					GameThread:Wait(1)
				end)
			end
			
			ActiveMenu.YesButton.OnReleased = function()
				ActiveMenu.YesButton.OnReleased = nil
				GameThread:Spawn(function()
					ActiveMenu.FadeScreen = ActiveMenu.Menu:GetChild("FadeScreen")
					ActiveMenu.FadeScreen:SetSize(9999, 9999)
					ActiveMenu.FadeScreen:SetColorFade(1, 2)
					ActiveMenu.FadeScreen:SetColorImmediate(color(0,0,0,0))
					ActiveMenu.FadeScreen:SetColor(Black)
					
					--GameThread:Wait(1)
				
					ActiveMenu = PreviousMenu
					ActiveMenu.Items.EnableInput = false
					ActiveMission:HideIngameMenu()
					
					PopMenu("ConfirmMenu")
					
					AnalyticsSendScreenName(ActiveGameMode.Name)
					-- if (ActiveMission ~= nil) then
						-- ActiveMission:Destroy()
						-- ActiveMission = nil
					-- end
					
					ClearMenuStack()
					ActiveMenu = nil
				
					var("IntPause", 0)
					reloadscript()
					
				end)
			end
			
			ActiveMenu.Back = function()
				if (ActiveMenu.NoButton.OnReleased ~= nil) then
					ActiveMenu.NoButton:OnReleased()
				end
			end
		end
	end
	
	
	
	--[[ self.TutorialSwitch = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_tutorialswitch"))
	self.TutorialSwitch.OnReleased = function()
		self.Items.Clicked = false
		
		-- Tutorial switch
		TutorialsEnabled = not TutorialsEnabled
		
		WriteGameSettings()
		
		if (TutorialsEnabled) then
			self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_on"))
		else
			self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_off"))
		end
	end
	
	if (TutorialsEnabled) then
		self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_on"))
	else
		self.TutorialSwitch:SetTextDirect(translate("button_tutorialswitch") .. " " .. translate("button_off"))
	end ]]
	
	
	
	self.Abort = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "button_abort"));	
	self.Abort.OnDeactivate = function()
		if (self:Active()) then
			self.Abort:Deactivate()
		end
	end
	
	self.Abort.OnClicked = function()
		if (self:Active()) then
			self.Abort:Activate()
		end
	end
	
	self.Abort.OnReleased = function()
		if (self:Active()) then
			ActiveMenu.Items.EnableInput = false
			PrevMenu = self --ActiveMenu
			ActiveMenu = ConfirmMenu(PrevMenu)
			
			--self.Header_text:SetText(Translate("confirm_abort"))
			--self.Text:SetText(Translate("confirm_abort_text"))
			
			ActiveMenu:SetTitle(Translate("confirm_abort"))
			ActiveMenu:SetText(Translate("confirm_abort_text"))
			ActiveMenu:SetCharacter(CharacterTextures["Johnny"], translate("character_Johnny"))
			
			if (PrevMenu.HideMenu ~= nil) then
				PrevMenu:HideMenu()
			end
			
			ActiveMenu.NoButton.OnReleased = function()
				ActiveMenu.NoButton.OnReleased = nil
				GameThread:Spawn(function()
					ActiveMenu.Main:SetColorImmediate(Invisible)
					PopMenu("ConfirmMenu")
					
					ActiveMenu = InGameMenu() --PrevMenu
					if (ActiveMenu.ShowMenu ~= nil) then
						ActiveMenu:ShowMenu()
					end
					ActiveMenu.Items.EnableInput = true
					
					--GameThread:Wait(1)
				end)
			end
			
			ActiveMenu.YesButton.OnReleased = function()
				ActiveMenu.YesButton.OnReleased = nil
				GameThread:Spawn(function()
					ActiveMenu.FadeScreen = ActiveMenu.Menu:GetChild("FadeScreen")
					ActiveMenu.FadeScreen:SetSize(9999, 9999)
					ActiveMenu.FadeScreen:SetColorFade(1, 2)
					ActiveMenu.FadeScreen:SetColorImmediate(color(0,0,0,0))
					ActiveMenu.FadeScreen:SetColor(Black)
					
					--GameThread:Wait(1)
			
					if (ActiveMission ~= nil) then
						ActiveMission:Destroy()
					end
			
					-- Dit moet om de mission te maken
					PrepareScript = function()
						ActiveMission = MenuMission()
					end

					var("IntPause", 0)
					--loadscript("menu")
					loadscript("menu")
					
					ClearMenuStack()
					ActiveBackground = nil
					ActiveForeground = nil
					
					ActiveMenu = MainMenu()
					
					PopMenu("ConfirmMenu")
				end)
			end
			
			ActiveMenu.Back = function()
				if (ActiveMenu.NoButton.OnReleased ~= nil) then
					ActiveMenu.NoButton:OnReleased()
				end
			end
		end
	end
	
	
	-- Lijst configureren en opmaken
	--self.Items.Active = InGameMenuSelection
	self.Items:Format(ALIGN_NS, 0, 0, 0, 40, Center, 0, Center, 0)

	if (true) then--if (GetPlatform() == "IOS" or GetPlatform() == "Android") then
		self.AudioButtonPanel = self.Menu:GetChild("AudioButton")
		self.Items.Panel = self.AudioButtonPanel
		self.Items.Panel:Clear()
		self.AudioSwitch = AudioSwitch(self.Items, "Elements\\AudioSwitch.dcMenu")
		self.AudioSwitch.OnReleased = function()
			if (tonumber(getvar("MusicVolume")) == 0) then
				self.AudioSwitch:TurnOn()
			elseif (tonumber(getvar("MusicVolume")) == MusicVolume) then
				self.AudioSwitch:TurnOff()
			else
				self.AudioSwitch:TurnOff()
			end
		end
		self.AudioSwitch:Init()
	end
	
	--self.Items:SetSelection(self.Resume)
	
	AddKeyListeners(BackButtons, "Down", function(Listeners)
		if (self:Active() and not ActiveMenu:is_a(ConfirmMenu)) then
			GameThread:Spawn(function()
				GameThread:Wait(0.1)
				ActiveMission:HideIngameMenu()
			end)
		else
			--DelKeyListeners(Listeners)
		end
	end)
	
	AddKeyListeners(SelectButtons, "Down", function(Listeners)
		if (self:Active() and not ActiveMenu:is_a(ConfirmMenu)) then
			if (self.Items:GetSelection() ~= nil) then
				self.Items:GetSelection():OnReleased()
			end
		else
			--DelKeyListeners(Listeners)
		end
	end)
end)

function InGameMenu:Active()
	if (ActiveMenu == self) then
		return true
	elseif (ActiveMenu ~= nil and ActiveMenu:is_a(ConfirmMenu)) then
		return true
	end
	
	return false
end

function InGameMenu:Refresh()
	ActiveMenu = InGameMenu()
end

function InGameMenu:HideMenu()
	--self.Main:SetColorFade(1, 8)
	--self.Main:SetColor(Invisible)
	
	--self.Main:SetColorData(White, 1, None, false)
	self.Main:SetColorData(Invisible, 3, Sine, false)
	self.AudioButtonPanel:Clear()
end

function InGameMenu:ShowMenu()
	--self.Main:SetColorFade(1, 8)
	--self.Main:SetColor(White)
	
	--self.Main:SetColorData(Invisible, 1, None, false)
	self.Main:SetColorData(White, 2, Sine, false)
end

function InGameMenu:ToggleMenu()
	print ("^2Back")

	--self.Main:setcolor(Invisible)
	--ActiveMenu = nil
	--InGameMenuSelection = 0;
	
	if (HUD ~= nil) then
		--HUD:Resume()
	end
end

function InGameMenu:Back()
	GameThread:Spawn(function()
		GameThread:Wait(0.1)
		ActiveMission:HideIngameMenu()
	end)
end

function InGameMenu:Proceed()
	--
end

function InGameMenu:SetInfoText()
	local ItemID = self.Items:GetSelectedID()

	if (ItemID == 'respawn') then
		self.InfoItemsText_Flash:settext(translate("RESPAWN_INFO"))
		self.InfoItemsText:settext(translate("RESPAWN_INFO"))
	elseif (ItemID == 'resume') then
		self.InfoItemsText_Flash:settext(translate("RESUME_INFO"))
		self.InfoItemsText:settext(translate("RESUME_INFO"))
	elseif (ItemID == 'restart') then
		self.InfoItemsText_Flash:settext(translate("RESTART_INFO"))
		self.InfoItemsText:settext(translate("RESTART_INFO"))		
	elseif (ItemID == 'options') then
		self.InfoItemsText_Flash:settext(translate("OPTIONS_INFO"))
		self.InfoItemsText:settext(translate("OPTIONS_INFO"))
	elseif (ItemID == 'abort') then
		self.InfoItemsText_Flash:settext(translate("ABORT_INFO"))
		self.InfoItemsText:settext(translate("ABORT_INFO"))
	end

	self.InfoItemsText_Flash:setcolorimmediate(White10)
	self.InfoItemsText_Flash:setcolor(Invisible)
end

function InGameMenu:Update(ElapsedTime)
	--
end

function InGameMenu:UpdatePhysics(ElapsedTime)
	--
end