LogoMenu = class(function(self)
	-- gooi menu er op
	self.Menu = PushMenu("LogoMenu")

	self.Main = self.Menu:GetChild("Main")
	self.Main:SetColorFade(1, 10)
	self.Main:SetColor(White)
	
	local Background = self.Menu:GetChild("Background")

	local ImageButton = self.Menu:GetChild("Image")
	ImageButton:SetColorImmediate(Invisible)
	--ImageButton:SetColorFade(1, 2)

	local Logos = {{Texture = texture('GameMillPublishing_Logo.DCT'), Sound = nil}, 
					{Texture = texture('FeldMotorSports_Logo.DCT'), Sound = nil}, 
					{Texture = texture('Intro_T6.DCT'), Sound = "Developer"}}

	self.Wait = true
	
	--Key listeners instellen
	local CutsceneProceedButtons = table.copy(ProceedButtons)
	table.insert(CutsceneProceedButtons, "DCK_MOUSE0")
	
	AddKeyListeners(CutsceneProceedButtons, "Down", function(Listeners)
		if (self:Active()) then
			if (self.Thread ~= nil) then
				GameThread:Resume(self.Thread)
			else
				self.Wait = false
			end
		else
			DelKeyListeners(Listeners)
		end
	end)
	
	GameThread:Spawn(function(Thread)
		-- =========================================
		-- Deze er nog ff uithalen
		GameThread:Sleep(0.3)

		-- Fade het plaatje in
		ImageButton:SetColorData(White, 1, Linear, false)
		ImageButton:SetImage(Logos[1].Texture)

		-- Nu mogen we skippen
		self.Thread = Thread

		-- Wacht 5 seconden
		GameThread:Sleep(5)

		-- Nu niet meer skippen
		self.Thread = nil

		-- Fade het plaatje uit
		ImageButton:SetColorData(Invisible, 4, Linear, false)

		-- =========================================
		-- Wacht 1 seconde
		GameThread:Sleep(1)
		
		-- Fade het plaatje in
		ImageButton:SetColorData(White, 1, Linear, false)
		ImageButton:SetImage(Logos[2].Texture)
		
		self.Thread = Thread
		
		-- Wacht 5 seconden
		GameThread:Sleep(5)

		-- Nu niet meer skippen
		self.Thread = nil
		
		-- Fade het plaatje uit
		ImageButton:SetColorData(Invisible, 4, Linear, false)
		
		-- =========================================
		-- Wacht 1 seconde
		GameThread:Sleep(1)		

		ImageButton:SetColorData(White, 1, Linear, false)
		ImageButton:SetImage(Logos[3].Texture)
		
		if (Logos[3].Sound ~= nil) then
			playsound(Logos[3].Sound .. ".wav")
		end
		
		GameThread:Sleep(1)
		
		self.Thread = Thread
		
		GameThread:Sleep(5)
		
		self.Thread = nil
		
		ImageButton:SetColorData(Invisible, 4, Linear, false)
		
		GameThread:Spawn(function(Thread)
			self.Main:SetColorFade(1, 10)
			self.Main:SetColor(Invisible)
			
			GameThread:Sleep(1)

			ActiveMenu = IntroMenu()
		end)
	end)
end)

function LogoMenu:Active()
	return ActiveMenu == self
end

function LogoMenu:CreateSound(FileName, Volume, Pitch)
	CreateSound(FileName, false, function(Sound)
		Sound:SetVolume(Volume)
		Sound:SetPitch(Pitch)
		Sound:Play(false, function()
			Sound:Destroy()
		end)
	end)
end

function LogoMenu:Back()
	if (self.Thread ~= nil) then
		GameThread:Resume(self.Thread)
	else
		self.Wait = false
	end
end

function LogoMenu:Proceed()
	if (self.Thread ~= nil) then
		GameThread:Resume(self.Thread)
	else
		self.Wait = false
	end
end

function LogoMenu:Refresh()
	ActiveMenu = LogoMenu()
end

function LogoMenu:MouseClick(Item)
	--
end

function LogoMenu:MouseRelease(Item)
	if (self.Thread ~= nil) then
		GameThread:Resume(self.Thread)
	else
		self.Wait = false
	end
end

function LogoMenu:MouseActivate(Item)
	--
end

function LogoMenu:WaitTimer()
	if (self.Wait) then
		GameThread:Sleep(0.16)
	else
		GameThread:Sleep(0.02)
	end
end
		
			