FirstPressed = false

MainMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu 
	
	CheckOnlineProgress()
	
	RestoreProducts()
	
	AnalyticsSendScreenName("MainMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("MainMenu", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")
	
		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
	
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
	
		-- Panels leegmaken en lijst aanmaken
		ActiveForeground:HideInfoText()
		self.Items = NewItemList(self, UpButtons, DownButtons) --, function() self:UpdateInfoText() end)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
	
		self.ButtonTemplate = "Elements\\MenuButton.dcMenu"
		self.ImageButtonTemplate = "Elements\\MenuImage.dcMenu"
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		self.StartGame = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_play"))
		self.StartGame.OnReleased = function()
			
			local Skip = tonumber(getvar("SkipChooseControls"))
			if (Skip == nil or Skip == 0) then
				if (self:Active()) then
					self:HideMenu()
					ShowConfirm_ChooseControls()
				end
				
			else
				self:Goto(GameModeSelect)
				--self:Goto(LiveEventMenu)
			end
			
			AnalyticsSendEvent("MainMenu", "ButtonClicked", "StartGame", "1")
			if(not FirstPressed) then
				AnalyticsSendEvent("MainMenu", "FirstClick", "StartGame", "1")
				FirstPressed = true
			end
		end
		self.StartGame:Flash(1, true, true, 0.5)
	
		--[[ self.DailyRewardsMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_dailyrewards"))
		self.DailyRewardsMenu.OnReleased = function()
			self:Goto(DailyRewardsMenu)
		end ]]
		
		self.UpgradesMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_upgrades"))
		--self.UpgradesMenu:Disable()
		self.UpgradesMenu.OnReleased = function()
			self:Goto(UpgradesMenu)
			AnalyticsSendEvent("MainMenu", "ButtonClicked", "UpgradesMenu", "1")
			if(not FirstPressed) then
				AnalyticsSendEvent("MainMenu", "FirstClick", "UpgradesMenu", "1")
				FirstPressed = true
			end
		end
	
		--[[ self.NewsFeedMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_newsfeed"))
		--self.FreeGoodsMenu:Disable()
		self.NewsFeedMenu.OnReleased = function()
			-- self:Goto(NewsFeedMenu)
			AnalyticsSendEvent("MainMenu", "ButtonClicked", "NewsFeedMenu", "1")
			if(not FirstPressed) then
				AnalyticsSendEvent("MainMenu", "FirstClick", "NewsFeedMenu", "1")
				FirstPressed = true
			end
			
			--AnalyticsSendScreenName("Monsterjam news")
			openwebsite("http://www.monsterjam.com/")
			
			self.Items.Clicked = false
		end ]]
	
		self.FreeGoodsMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_FreeGoods"))
		--self.FreeGoodsMenu:Disable()
		self.FreeGoodsMenu.OnReleased = function()
			self:Goto(FreeGoodsMenu)
			AnalyticsSendEvent("MainMenu", "ButtonClicked", "FreeGoodsMenu", "1")
			if(not FirstPressed) then
				AnalyticsSendEvent("MainMenu", "FirstClick", "FreeGoodsMenu", "1")
				FirstPressed = true
			end
		end	
		-- self.FreeGoodsMenu:Flash(1, true, true, 0.5)
		
		
		--Checken als er wel een reward is
		if (Kiip.RewardAvailable) then
			self.RedeemKiipReward = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButtonKiipReward.dcMenu", "Redeem Reward"))
			self.RedeemKiipReward.Selectable = false
			self.RedeemKiipReward.Background:SetColorData(color(0.45, 0.3, 0.8, 1), 0, None, false)
			self.RedeemKiipReward.OnReleased = function()
				self.RedeemKiipReward.OnReleased = nil
				
				Kiip:RedeemReward()
				self.Items.Clicked = false
				
				self.RedeemKiipReward.Item:SetColorFade(1, 6)
				self.RedeemKiipReward.Item:SetColor(Invisible)
			end
		end
		
		
	
		--[[ if(FBManager:IsLoginValid()) then
		--if (false) then
			self.FriendsMenu = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButtonFB.dcMenu", "menu_friends"))
			--self.FriendsMenu:Disable()
			self.FriendsMenu.OnReleased = function()
				self:Goto(FriendsMenu)
			end
		end ]]

		--[[ self.Options = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, self.ButtonTemplate, "menu_options"))
		--self.Options:Disable()
		self.Options.OnReleased = function()
			print("^3Mainmenu ^7> ^2OptionsMenu")
		
			self:Goto(OptionsMenu)
		end ]]
	
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
	
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
	
		self.CreditsButton = self.Items:AddItem(self.BottomBarItems, MenuElements.ImageButton(self.Items, self.ImageButtonTemplate, "menu_credits", DeveloperTexture))
		table.insert(self.MenuDelItem_Queue, self.CreditsButton)
		self.CreditsButton.OnReleased = function()
			print("^3OptionsMenu ^7> ^2ExtraCredits")
			--Kiip:SaveMoment("mj_3_racing")
			self:Goto(ExtrasCredits)
		end
		
		--if(FBManager:IsLoginValid()) then
			--self.FacebookLogoutButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonFB.dcMenu", "button_facebooklogout"))
			self.FacebookLogoutButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButton.dcMenu", "menu_options"))
			self.FacebookLogoutButton.Selectable = false
			table.insert(self.MenuDelItem_Queue, self.FacebookLogoutButton)
			self.FacebookLogoutButton.OnReleased = function()
				--self:Goto(IntroMenu)
				--FBManager:Logout(nil)
				
				self:Goto(OptionsMenu)
			end
		--end
		
		local RedeemEnabled = false --GetRedeemData("Enabled")
		
		if (RedeemEnabled) then
			self.RedeemButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButton.dcMenu", "menu_redeemcode"))
			self.RedeemButton.Background:SetColorData(color(0.45, 0.3, 0.8, 1), 0, None, false)
			self.RedeemButton.Selectable = false
			table.insert(self.MenuDelItem_Queue, self.RedeemButton)
			self.RedeemButton.OnReleased = function()
				--print("^3OptionsMenu ^7> ^2ExtraCredits")
				--self:Goto(ExtrasCredits)
				self:Goto(RedeemMenu)
			end
		end
	
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
	
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Left, 0, Left, 0, 0, self.TotalNormalButtons)
	
		-- Format back button
		--self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		--self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Right, Top, Right, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		-- Format Credits button
		self.CreditsButton:Format(ALIGN_NS, SafeFrameOffsetX, 0, 0, 0, Left, Top, Right, Top)
		self.CreditsButton:FormatTween(ALIGN_NS, 0, 0, 0, 0, Right, Top, Right, Top)
		
		-- Format FacebookLogout button
		if (self.FacebookLogoutButton ~= nil) then
			self.FacebookLogoutButton:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top)
			self.FacebookLogoutButton:FormatTween(ALIGN_NS, 0, 0, 0, 0, Left, Top, Left, Top)
		end
		
		if (self.RedeemButton ~= nil) then
			self.RedeemButton:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Center, Top, Center+ 0.1, Top)
			self.RedeemButton:FormatTween(ALIGN_NS, 0, 0, 0, 0, Center, Top, Center+ 0.1, Top)
		end
	
		--self.Items:SetSelection(self.StartGame)
	
		if (true) then--if (GetPlatform() == "IOS" or GetPlatform() == "Android") then
			self.AudioButtonPanel = self.Menu:GetChild("AudioButton")
			self.Items.Panel = self.AudioButtonPanel
			self.Items.Panel:Clear()
			self.AudioSwitch = AudioSwitch(self.Items, "Elements\\AudioSwitch.dcMenu")
			self.AudioSwitch.OnReleased = function()
				if (tonumber(getvar("MusicVolume")) == 0) then
					self.AudioSwitch:TurnOn()
				elseif (tonumber(getvar("MusicVolume")) == MusicVolume) then
					self.AudioSwitch:TurnOff()
				else
					self.AudioSwitch:TurnOff()
				end
			end
			self.AudioSwitch:Init()
		end
	
		--Add KeyListeners
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				self:Back()
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	
		if(ActiveGameMode:GetSelectedCar().Bought) then
			ActiveForeground:SetCarName(ActiveGameMode:GetSelectedCar().Name, ActiveGameMode:GetSelectedCar().TierNumber)
		end
		
		-- Truck Images
		self.TruckImage = self.Menu:GetChild("TruckImage")
		
		
		local TruckImages = {}
		for i, Car in ipairs(MonsterTruckCars.Cars) do
			print(Car.TruckImage)
			if (Car.TruckImage ~= nil) then
				table.insert(TruckImages, Car.TruckImage)
			end
		end
		
		local RandomInt = math.random(1, #TruckImages)
		local RandomTexture = TruckImages[RandomInt]
		
		self.TruckImage:SetImage(RandomTexture)
		self.TruckImage:SetColorImmediate(White)
		self.UpdateScreen = MenuElements.UpdatePopup("elements\\UpdatePopup.dcMenu", self.Menu:GetChild("UpdateScreen"))
	end)
end)

function MainMenu:Goto(Target)
	if (self:Active()) then
		ActiveMenu = Target(MainMenu)
		self:HideMenu()
		
		if (self.DeleteButtons ~= nil) then
			self:DeleteButtons()
		end
	end
end

function MainMenu:Active()
	return ActiveMenu == self
end

function MainMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = MainMenu(PreviousMenu)
end

function MainMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function MainMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function MainMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function MainMenu:Back()
	ShowConfirm_Exit()
end
-- ==========================================
-- Custom functions below here
-- ==========================================
function MainMenu:UpdateInfoText()
	if (ActiveForeground ~= nil) then
		if (ActiveForeground.SetInfoText ~= nil and ActiveForeground.ShowInfoText ~= nil and ActiveForeground.HideInfoText ~= nil) then
			ActiveForeground:ShowInfoText()
			
			local SelectedItem = self.Items:GetSelection()
			local Description = SelectedItem.Description
			if (Description ~= nil) then
				ActiveForeground:SetInfoText(Translate(Description))
			else
				ActiveForeground:HideInfoText()
			end
		end
	end
end