OptionsMenu = class(function(self, PreviousMenu)
	self.PreviousMenu = PreviousMenu
	
	AnalyticsSendScreenName("OptionsMenu")
	-- Gooi menu er op
	self.Menu = ActiveMenu_PushMenuAsync("OptionsMenu", nil, function()
		-- Pak het hoofdpanel
		self.Main = self.Menu:GetChild("Main")

		-- SafeFrame pakken en zetten
		self.SafeFrame = self.Menu:GetChild("SafeFrame")
		self.SafeFrame:SetSize(SafeFrameWidth, SafeFrameHeight)
		
		--
		self.BottomBarItems = ActiveForeground.Menu:GetChild("BottomBarItems")
		
		--Show menu
		self.MenuDelItem_Queue = {}
		self:ShowMenu()
		
		-- Panels leegmaken en lijst aanmaken
		self.Items = NewItemList(self, UpButtons, DownButtons)
		self.ItemsPanel = self.Menu:GetChild("Items")
		self.ItemsPanel:Clear()
		
		self.ButtonTemplate = "Elements\\FreeGoodsButton.dcMenu"

		
		-- Add Normal buttons
		self.TotalNormalButtons = 0
		
		local UserID = ""
		if (false) then
			UserID = tostring(FBManager.UserinfoTable['HighscoresID'])
		end
		
		local InfoString = ""
		if (GetPlatform() == "Win32") then
			InfoString = InfoString .. "W:"
		elseif (GetPlatform() == "Android") then
			InfoString = InfoString .. "A:"
		elseif (GetPlatform() == "IOS") then
			InfoString = InfoString .. "I:"
		else
			InfoString = InfoString .. "O:"
		end
		
		InfoString = InfoString .. "K:" .. tostring(GetKeychainValue("UserID"))
		InfoString = InfoString .. ":F:" .. tostring(FBManager.UserinfoTable['HighscoresID'])
		InfoString = InfoString .. ":S:"..tostring(Scores.UserID)
		
		if(FBManager:IsLoginValid()) then
		--if(false) then
			--self.Login_User = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", GetPlayername() .. " UserID: " .. tostring(Scores.UserID) .. " FacebookID: " .. tostring(FBManager.UserinfoTable['id']) .. " HighscoresID: " .. tostring(FBManager.UserinfoTable['HighscoresID'])))
			self.Login_User = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", GetPlayername()))
			self.Login_InfoString = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", InfoString))
			
			self.Login_Simple = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButtonFB_Login.dcMenu", "button_facebooklogout"))
			self.Login_Simple.OnReleased = function()
				self:Goto(IntroMenu)
				FBManager:Logout(nil)
			end
		else
			--self.Login_User = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", GetPlayername() .. " UserID: " .. tostring(Scores.UserID) .. " FacebookID: " .. tostring(FBManager.UserinfoTable['id']) .. " HighscoresID: " .. tostring(FBManager.UserinfoTable['HighscoresID'])))
			self.Login_User = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", GetPlayername()))
			self.Login_InfoString = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuLabel.dcMenu", InfoString))
			
			if (ScoresUser.Online) then
				self.ChangeUserName = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButton_Big.dcMenu", "button_ChangeUserName"))
				self.ChangeUserName.OnReleased = function()
					self:Goto(ChangeNameMenu, true)
				end
			end
			
			self.Login_Facebook = self.Items:AddItem(self.ItemsPanel, MenuElements.Label(self.Items, "Elements\\MenuButtonFB_Login.dcMenu", "button_Facebook_Login_Long"))
			self.Login_Facebook.OnReleased = function()
				self:Goto(IntroMenu, true)
				--FBManager:Login(nil)
			end
		end
		
		-- =========
		
		--[[ function ShowConfirm_ShadowsWarning(CheckboxElement)
			PreviousMenu = ActiveMenu
			ActiveMenu = ConfirmMenu(PreviousMenu)
			ActiveMenu:SetTitle(Translate("confirm_shadowswarning_title"))
			ActiveMenu:SetText(string.format(Translate("confirm_shadowswarning_text"), FreeCoins))
			ActiveMenu:SetCharacter(CharacterTextures["Pete"], Translate("character_Pete"))
			ActiveMenu:SetProceedText(Translate("menu_yes"))
			ActiveMenu:SetCancelText(Translate("menu_no"))
			
			ActiveMenu.CancelAction = function()
				GameThread:Spawn(function()
					CheckboxElement:Uncheck()
				end)
			end
		end ]]
		
		local ShadowsEnabled = tonumber(getvar("Shadows"))
		if (ShadowsEnabled == nil or ShadowsEnabled > 0) then
			ShadowsEnabled = true
		else
			ShadowsEnabled = false
		end
		
		self.ShadowCheckBox = self.Items:AddItem(self.ItemsPanel, MenuElements.Checkbox(self.Items, "Elements\\MenuCheckbox.dcMenu", "menu_shadow_enabled", ShadowsEnabled))
		self.ShadowCheckBox.OnChange = function(Checked)
			if (Checked) then
				var("Shadows", 1)
				--ShowConfirm_ShadowsWarning(self.ShadowCheckBox)
			else
				var("Shadows", 0)
			end
			configsave()
		end
		-- =========
		
		local UseAccelerometer = tonumber(getvar("UseAccelerometer"))
		if (UseAccelerometer == nil or UseAccelerometer > 0) then
			UseAccelerometer = true
		else
			UseAccelerometer = false
		end
		
		self.UseAccelerometerCheckBox = self.Items:AddItem(self.ItemsPanel, MenuElements.Checkbox(self.Items, "Elements\\MenuCheckbox.dcMenu", "menu_use_accelerometer", UseAccelerometer))
		self.UseAccelerometerCheckBox.OnChange = function(Checked)
			if (Checked) then
				var("UseAccelerometer", 1)
			else
				var("UseAccelerometer", 0)
			end
			configsave()
		end
		
		self.TotalNormalButtons = #self.Items.Items		-- Hoeveel normale buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		
		-- Add back button
		self.TotalBackButtons = 0						-- Hoeveel back buttons zitten er nu in de lijst? handig te weten voor de formatting!
		
		self.BackButton = self.Items:AddItem(self.BottomBarItems, MenuElements.Label(self.Items, "Elements\\MenuButtonBack.dcMenu", "button_back"))
		self.TotalBackButtons = self.TotalBackButtons + 1
		table.insert(self.MenuDelItem_Queue, self.BackButton)
		self.BackButton.OnReleased = function()
			--self:Goto(self.PreviousMenu)
			self:Goto(MainMenu)
		end
		
		
		-- Settings voor formatting
		self.TotalListButtons = #self.Items.Items 		-- Hoeveel buttons zitten er nu in de lijst? handig te weten voor de formatting!
		local ButtonOffset = 9
		local ButtonSpace = 16 + 16
		local NormalButtonOffset = self.TotalNormalButtons * ButtonOffset
		local TotalButtonOffset = self.TotalListButtons * ButtonOffset
		
		-- Format normal buttons
		self.Items:Format(ALIGN_NS, -NormalButtonOffset - SafeFrameOffsetX, 0, 0, ButtonSpace, Right, 0, Left, 0, 0, self.TotalNormalButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, ButtonSpace, Center, 0, Center, 0, 0, self.TotalNormalButtons)
		
		-- Format back button
		self.Items:Format(ALIGN_NS, -SafeFrameOffsetX, 0, 0, 0, Right, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		self.Items:FormatTween(ALIGN_NS, 0 , 0, 0, 0, Left, Top, Left, Top, self.TotalNormalButtons, self.TotalNormalButtons + self.TotalBackButtons)
		
		self.Items:SetSelection(self.FreeGoodsLikeDevButton)
		
		AddKeyListeners(BackButtons, "Down", function(Listeners)
			if (self:Active()) then
				--self:Goto(self.PreviousMenu)
				self:Goto(MainMenu)
			else
				DelKeyListeners(Listeners)
			end
		end)
		
		AddKeyListeners(SelectButtons, "Down", function(Listeners)
			if (self:Active()) then
				if (self.Items:GetSelection() ~= nil) then
					self.Items:GetSelection():OnReleased()
				end
			else
				DelKeyListeners(Listeners)
			end
		end)
	end)
end)

function OptionsMenu:Goto(Target, Parameter)
	ActiveMenu = Target(OptionsMenu, Parameter)
	self:HideMenu()
	
	if (self.DeleteButtons ~= nil) then
		self:DeleteButtons()
	end
end

function OptionsMenu:Active()
	return ActiveMenu == self
end

function OptionsMenu:Refresh()
	local PreviousMenu = self.PreviousMenu
	ActiveMenu = OptionsMenu(PreviousMenu)
end

function OptionsMenu:ShowMenu()
	self.Main:SetColorImmediate(White)
	
	if (self.MenuDelItem_Queue ~= nil) then
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			MenuItem.Item:SetColor(White)
		end
	end
end

function OptionsMenu:HideMenu()
	self.Main:SetColorFade(1, 4)
	self.Main:SetColor(Invisible)
	
	--Fade MenuItems
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.Item:SetColorFade(1, 4)
		MenuItem.Item:SetColor(Invisible)
	end
end

function OptionsMenu:DeleteButtons()
	for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
		MenuItem.OnReleased = nil
	end

	--Delete MenuItems
	GameThread:Spawn(function()
		GameThread:Wait(0.4)
		for i, MenuItem in ipairs(self.MenuDelItem_Queue) do
			self.BottomBarItems:DelItem(MenuItem.Item)
			MenuItem.Item:Destroy()
		end
	end)
end

function OptionsMenu:Back()
	self:Goto(MainMenu)
end