-- text item
MenuLabel = class(function(self, Panel, Template, Name)
	self.Panel = Panel
	self.Item = Panel:AddItem(Template);
	self.Item:SetColorFade(1, 8)
	
	self.NameItem = self.Item:GetChild("Name")
	self.NameItem2 = self.Item:GetChild("Name2")
	
	self.Color = White;
	self.FlashColor = White;
	
	-- Init
	
	self.Item:SetColorImmediate(Halfblack)
	
	self.NameItem:SetText(translate(Name))
	self.NameItem:SetColorFade(1, 10)
	self.NameItem:SetColorImmediate(self.Color);
	
	self.NameItem2:SetText(translate(Name))
	self.NameItem2:SetColorFade(1, 4)
	self.NameItem2:SetColorImmediate(self.Color);
end)

function MenuLabel:Left()
	--
end

function MenuLabel:Right()
	--
end

function MenuLabel:SetText(Text)
	self.NameItem:SetText(translate(Text))
	self.NameItem2:SetText(translate(Text))
end

function MenuLabel:Activate(First) -- standaard multilist selectie kleuren 
	if (self.Enabled) then
		if (First) then
			self.Item:SetColorImmediate(SelectDarkOrange)
			self.NameItem:SetColorImmediate(White)
			self.NameItem2:SetColorImmediate(Invisible)
		else
			self.Item:SetColorImmediate(White)
			self.Item:SetColor(SelectDarkOrange)
			self.NameItem2:SetColorImmediate(White)
			self.NameItem:SetColor(White)
			self.NameItem2:SetColor(Invisible)
		end
	end
end

function MenuLabel:Deactivate()
	if (self.Enabled) then
		self.Item:SetColor(Halfblack)
		self.NameItem:SetColor(Darkish)
		self.NameItem2:SetColorImmediate(Invisible)
	end
end

function MenuLabel:DelItem(Index)
	self.Panel:DelItem(Index)
end