ScreenMessages = {}

UID = 0
ScreenMessage = class(function(self, Panel, Menufile, Text, TimeDelay, PosX, PosY, DirX, DirY, TextColor)

	--local HUD = ActiveMission.HumanPlayers[1].HUD
	self.MainPanel = Panel

	--self.Panel = self.Menu:AddItem("hud\\elements\\health.dcMenu")
	self.Panel = self.MainPanel:AddItem(Menufile)
	--self.Panel = pushmenu(Menufile)
	self.Text = translate(Text)
	self.TimeDelay = TimeDelay
	self.PosX = PosX
	self.PosY = PosY
	self.DirX = DirX
	self.DirY = DirY
	
	--self.Panel:SetPanelAlignTween(0, 1, 0, 0, false, 1)
	--self.Panel:SetPanelAlignTween(0, 0, 10, 0, false, 1)
	
	--self.Panel:SetPosData(0, 0, Center, Bottom, Center, Bottom, 0, None, false)
	--self.Panel:SetPosData(0, 0, Center, Bottom, Center, Bottom, 0, Linear, false)
	--self.Panel:SetPosData(0, 0, Center, Top, Center, Top, 10, Linear, false)
	
	if (self.DirX == nil) then
		self.DirX = 0
	end
	if (self.DirY == nil) then
		self.DirY = -5.5
	end
	
	self.Panel:SetPos(self.PosX, self.PosY)
	
	self.TextButton = self.Panel:GetChild("Text")
	self.TextButton:settext(self.Text)
	
	table.insert(ScreenMessages, self)
	UID = UID + 1
	self.ID = UID
	self.Panel:setintname(self.ID)
	
	
	self.Panel:SetColorImmediate(Invisible)
	self.Panel:setcolorfade(1, 10)
	self.Panel:SetColor(White)
	
	--print(self.ID .. 'added')
	
	if (TextColor ~= nil) then
		self.TextButton:SetColor(TextColor)
	end
	
	--update hier met physicsthread
	PhysicsThread:Spawn(function()
		while (true) do
			self:Update(1 / 60)
			PhysicsThread:Sleep(1 / 60)
		end
	end)
end)

function ScreenMessage:Update(ElapsedTime)
	self.TimeDelay = self.TimeDelay - ElapsedTime
	
	if (self.TimeDelay < 0 and self.Panel ~= nil) then
		
		--local HUD = ActiveMission.HumanPlayers[1].HUD
		self.MainPanel:RemoveChild(self.ID)
		--print(self.ID .. 'removed')
		
		for i = 1, #ScreenMessages do
			local Message = ScreenMessages[i]
			
			if (Message ~= nil) then
				if (Message.ID == self.ID) then
					table.remove(ScreenMessages, i)
					i = i - 1
				end
			end
		end
		
		self.Panel = nil
		
		return true
	else
		if (self.Panel ~= nil) then
			--self.PosY = self.PosY - 3.5
			--self.PosY = self.PosY - 1.5
			self.PosX = self.PosX + self.DirX
			self.PosY = self.PosY + self.DirY
			self.Panel:SetPos(self.PosX, self.PosY)
			
			if (self.TimeDelay < 1) then
				self.Panel:SetColor(Invisible)
			end
		end
		
		return false
	end
end

function ScreenMessage:UpdateText(NewText)
	self.Text = translate(NewText)
	self.TextButton:settext(self.Text)
end

function ScreenMessage:Visible()
	for i = 1, #ScreenMessages do
		local Message = ScreenMessages[i]
		if (Message ~= nil) then
			if (Message.ID == self.ID) then
				return true
			end
		end
	end
	
	return false
end