BounceBackForthStunt = class(BaseBounceStunt, function(self)
	self.IdleTimeMax = 1.5
	--self.ID = SCORE_FORWARD_BOUNCE
	self.ScreenName = "stunt_title_forward_bounce"
	
	-- Forward lean state
	self.LeanFirstState = WheelsState()
	self.LeanFirstState.Wheels[0] = true
	self.LeanFirstState.Wheels[1] = true
	self.LeanFirstState.Wheels[2] = false
	self.LeanFirstState.Wheels[3] = false
	
	-- Backward lean state
	self.LeanSecondState = WheelsState()
	self.LeanSecondState.Wheels[0] = false
	self.LeanSecondState.Wheels[1] = false
	self.LeanSecondState.Wheels[2] = true
	self.LeanSecondState.Wheels[3] = true
end)

function BounceBackForthStunt:OnDeactivated()
	self:CalculateScore()
	
	DailyMissionsManager:StartChecking(self, "Challenge_1")
	
	local Result = self:CreateResult()
	Result.Bounces = self.Bounces
	Result.Message = "Forward bounce x" ..self.Bounces
	
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\ForwardBounce.wav")
end

function BounceBackForthStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt

	--print(self.Player.Scores[self.ID] )
end