BounceLeftRightStunt = class(BaseBounceStunt, function(self)
	self.IdleTimeMax = 1.5
	--self.ID = SCORE_SIDEWAYS_BOUNCE
	self.ScreenName = "stunt_title_sideways_bounce"
	
	-- Right lean state
	self.LeanFirstState = WheelsState()
	self.LeanFirstState.Wheels[0] = true
	self.LeanFirstState.Wheels[1] = false
	self.LeanFirstState.Wheels[2] = true
	self.LeanFirstState.Wheels[3] = false
	
	-- Left lean state
	self.LeanSecondState = WheelsState()
	self.LeanSecondState.Wheels[0] = false
	self.LeanSecondState.Wheels[1] = true
	self.LeanSecondState.Wheels[2] = false
	self.LeanSecondState.Wheels[3] = true
end)

function BounceLeftRightStunt:OnDeactivated()
	local Result = self:CreateResult()
	
	Result.Bounces = self.Bounces
	Result.Message = "Sideways bounce x" ..self.Bounces
	
	self:CalculateScore()
	self.Player.Scores[self.ID] = Max(self.Score, self.Player.Scores[self.ID])
	
	self:AddResult(Result)
	playsound("Moves\\SideWaysBounce.wav")
end

function BounceLeftRightStunt:CalculateScore()
	self.Score = self.Player.MaxScorePerStunt

	--print(self.Player.Scores[self.ID] )
end