WheelsState = class(function(self, car)
	self.Wheels = {}
	self.Flagged = false
	
	if(car ~= nil) then
		self.Car = car
		for i = 0, 3 do
			self.Wheels[i] = not self.Car:IsWheelLoose(i)
		end
	end
end)

function WheelsState:__eq(op1)
	return self.Wheels[0] == op1.Wheels[0]
		and self.Wheels[1] == op1.Wheels[1]
		and self.Wheels[2] == op1.Wheels[2]
		and self.Wheels[3] == op1.Wheels[3]
end

function WheelsState:__tostring()
	return "{ Wheel 0: " ..(self.Wheels[0] and "true" or "false")
		.."; Wheel 1: " .. (self.Wheels[1] and "true" or "false")
		.."; Wheel 2: " .. (self.Wheels[2] and "true" or "false")
		.."; Wheel 3: " .. (self.Wheels[3] and "true" or "false")
		.." } "
end