SuspensionUpgrade = class(BaseUpgrade, function(self)
	self.Type = UpgradeTypes.Suspension
	
	self.MenuUpgrade = self.Upgrader:GetMenuCarUpgrade("garage_suspension")
	self:SetLevel(self.MenuUpgrade.CurrentLevel)
end)

function SuspensionUpgrade:Apply(CarBuilder)
	local ErpDecreaseFactor = 0.03 -- 0.02 / 0.7
	local CfmDecreaseFactor = 0.04 -- 0.000002 / 0.00005
	
	-- Increases/decreased per level
	--local ErpIncrease = -0.02 -- Hoe diep de auto kan doorzakken op zijn wielen op impact. (minder = minder zakken)
	--local CfmIncrease = -0.00000002 -- Bounciness wielen op impact (minder = minder bounciness)
	
	-- Tweak the suspension
	self:SetSuspension(CarBuilder, ErpDecreaseFactor, CfmDecreaseFactor)
	
	print("^2SuspensionUpgrade applied (level " ..self.Level ..").")
end