uniform vec4 WVP[4];

attribute vec4 Position;

vec4 mul4x4(vec4 V, vec4 M[4]){
	vec4 ret;
	
	ret.x = dot(V, M[0]);
	ret.y = dot(V, M[1]);
	ret.z = dot(V, M[2]);
	ret.w = dot(V, M[3]);
	
	return ret;
}

void main(){
	gl_Position = mul4x4(Position, WVP);
}
