uniform sampler2D Tex0;
uniform sampler2D FadeTex;

varying lowp vec4 fColor0;
varying lowp vec4 fColor1;
varying highp vec2 fTex;
varying highp vec2 fFade;

void main(){
    lowp float Fade  = texture2D(FadeTex, fFade).r;
    lowp vec4 Color = mix(fColor0, fColor1, Fade);
    
    gl_FragColor = texture2D(Tex0, fTex) * Color;
}

