uniform sampler2D Tex0;
uniform lowp vec4 LerpFogColor;

varying lowp vec4 fColor;
varying highp vec2 fTexCoord;
varying lowp float fFog;

void main(){
    lowp vec4 Color = texture2D(Tex0, fTexCoord, -1.5) * fColor;
    Color.rgb = mix(Color.rgb, LerpFogColor.rgb, fFog);
    gl_FragColor = Color;
}

