uniform sampler2D Tex0;
uniform lowp vec4 LerpFogColor;

uniform lowp vec4 FoliageColor;

varying highp vec2 fTexCoord;

void main(){
	lowp vec4 Diffuse = texture2D(Tex0, fTexCoord);
	
	if (Diffuse.a < 0.5){
		discard;
	}
		
	lowp vec4 Output = Diffuse * FoliageColor;

	gl_FragColor = Output;
}

