uniform vec4 World[3];

attribute vec2 Position;
attribute lowp vec4 Color0;
attribute vec2 TexCoord0;

varying lowp vec4 fColor;
varying vec2 fTexCoord;

void main() {
    vec2 InputPos = Position;
    
    vec2 P;
    P.x = InputPos.x * World[0].x + InputPos.y * World[0].y + World[0].w;
    P.y = InputPos.x * World[1].x + InputPos.y * World[1].y + World[1].w;
    
    fColor = Color0;
    fTexCoord = TexCoord0;
    gl_Position = vec4(P, 0, 1);
}
